
scoreboard players set action_delay timer 8

execute as @e[type=interaction,tag=p_auction_entity] at @s on target if score @s player_id = auction_turn player_id run tag @e[type=interaction,tag=p_auction_entity,sort=nearest,limit=1] add entity_selected

execute as @a[scores={player_id=1..}] if score @s player_id = auction_turn player_id at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.5

function monopoly:system/update_message_targets

execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=1] run scoreboard players add highest_bid money 1
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=10] run scoreboard players add highest_bid money 10
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=100] run scoreboard players add highest_bid money 100
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=!opt_out] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" raised the bid to ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true,"italic":true},{"score":{"name":"highest_bid","objective":"money"},"italic":true,"color":"aqua"},{"text":".","color":"gray","italic":true}]


execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] as @e[tag=token,scores={player_id=1..},tag=in_auction] if score @s player_id = auction_turn player_id run tag @s remove in_auction


execute as @e[type=interaction,tag=p_auction_entity,tag=entity_selected] at @s run particle minecraft:composter ~ ~0.3 ~ 0.2 0.2 0.2 0 20

execute unless entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] as @a at @s run playsound minecraft:block.amethyst_cluster.break master @s ~ ~1 ~ 1 2
execute unless entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] as @a at @s run playsound minecraft:block.piston.extend block @a ~ ~1 ~ 0.5 2
execute unless entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] unless entity @e[tag=p_auction_entity,tag=entity_selected,tag=1] as @a at @s run playsound minecraft:block.amethyst_cluster.break master @s ~ ~1 ~ 1.5 1
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=100] as @a at @s run playsound minecraft:block.amethyst_cluster.break master @s ~ ~1 ~ 2 0.5
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=100] as @a[scores={player_id=1..}] if score @s player_id = auction_turn player_id at @s run playsound minecraft:entity.generic.explode master @a ~ ~1 ~ 0.5 1.5
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] as @a[scores={player_id=1..}] if score @s player_id = auction_turn player_id at @s run playsound minecraft:block.note_block.bass master @a ~ ~1 ~ 2 0.8
execute if entity @e[tag=p_auction_entity,tag=entity_selected,tag=opt_out] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" withdrew from the auction.","color":"gray","italic":true}]

function monopoly:auction/auction_pass_turn

tag @e[tag=entity_selected] remove entity_selected
