
scoreboard players set house_count constants 32
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=1..4}] run scoreboard players operation house_count constants -= @s property_state
execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] run scoreboard players operation house_count constants -= @s extra_houses
scoreboard players set hotel_count constants 12
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=5..}] run scoreboard players remove hotel_count constants 1
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] run scoreboard players operation hotel_count constants -= @s extra_hotels

scoreboard players set house_count_temp constants 32
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=1..4}] run scoreboard players operation house_count_temp constants -= @s property_state
execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] unless score @s player_id = current_controller player_id run scoreboard players operation house_count_temp constants -= @s extra_houses
scoreboard players set hotel_count_temp constants 12
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=5..}] run scoreboard players remove hotel_count_temp constants 1
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] unless score @s player_id = current_controller player_id run scoreboard players operation hotel_count_temp constants -= @s extra_hotels

scoreboard players set action_delay timer 8
tag @a[scores={player_id=1..}] add update_inventory
execute as @e[type=interaction,tag=p_manage_entity] at @s on target if score @s player_id = current_controller player_id run tag @e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1] add entity_selected

execute as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,tag=entity_selected] if score house_count constants matches 1 if score house_count_temp constants matches 1 run scoreboard players set auction_id space_id 41
execute as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,tag=entity_selected] if score hotel_count constants matches 1 if score hotel_count_temp constants matches 1 run scoreboard players set auction_id space_id 42
execute as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=down,tag=house,tag=hotel,tag=entity_selected] if score house_count constants matches 1..4 if score house_count_temp constants matches 4 run scoreboard players set auction_id space_id 41


execute as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.5
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=!too_expensive,tag=entity_selected] at @s run playsound minecraft:ui.stonecutter.take_result block @a ~ ~ ~ 0.5 0.5 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=!too_expensive,tag=entity_selected] at @s run particle minecraft:composter ~ ~0.3 ~ 0.2 0.2 0.2 0 20
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=house,tag=entity_selected] at @s run playsound minecraft:ui.loom.take_result block @a ~ ~1 ~ 0.6 1 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=house,tag=entity_selected] at @s run playsound minecraft:block.anvil.destroy block @a ~ ~1 ~ 0.4 2 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=house,tag=entity_selected] at @s run playsound minecraft:block.wooden_door.open block @a ~ ~1 ~ 0.7 1.5 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=house,tag=entity_selected] at @s run playsound minecraft:block.anvil.land block @a ~ ~1 ~ 0.2 2 0.05
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=house,tag=entity_selected] at @s run playsound minecraft:block.piston.extend block @a ~ ~1 ~ 0.6 0.5 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=house,tag=entity_selected] at @s run playsound minecraft:entity.zombie.break_wooden_door block @a ~ ~ ~ 0.3 2 0.1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=house,tag=entity_selected] at @s run playsound minecraft:block.anvil.land block @a ~ ~1 ~ 0.3 1.8 0.05
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:block.iron_door.open block @a ~ ~ ~ 2 0.7
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:block.wooden_door.open block @a ~ ~ ~ 2 0.5
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:item.shield.break block @a ~ ~1 ~ 1 0.5
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:block.iron_door.open block @a ~ ~ ~ 2 0.9
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:block.iron_door.open block @a ~ ~ ~ 2 0.8
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:entity.player.levelup block @a ~ ~ ~ 0.5 0.8
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=mortgage,tag=entity_selected] at @s run playsound minecraft:entity.allay.item_thrown block @a ~ ~1 ~ 2 2
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s run scoreboard players add @e[type=marker,tag=space,sort=nearest,limit=1] property_state 1
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s run scoreboard players remove @e[type=marker,tag=space,sort=nearest,limit=1] property_state 1

execute unless score auction_id space_id matches 1.. as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players operation @s payment += @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=up,tag=entity_selected,limit=1] money
execute unless score auction_id space_id matches 1.. as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players operation @s payment -= @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=down,tag=entity_selected,limit=1] money

execute unless score auction_id space_id matches 1.. if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,scores={money=..0},tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_houses 1
execute unless score auction_id space_id matches 1.. if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,scores={money=..0},tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_hotels 1

execute unless score auction_id space_id matches 1.. if score house_count constants matches ..0 if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=down,tag=house,tag=hotel,tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_houses 1
execute unless score auction_id space_id matches 1.. if score house_count constants matches ..1 if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=down,tag=house,tag=hotel,tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_houses 1
execute unless score auction_id space_id matches 1.. if score house_count constants matches ..2 if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=down,tag=house,tag=hotel,tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_houses 1
execute unless score auction_id space_id matches 1.. if score house_count constants matches ..3 if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!no_building,tag=!too_expensive,tag=down,tag=house,tag=hotel,tag=entity_selected] as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players remove @s extra_houses 1


execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 0 at @s run particle happy_villager ~ ~0.1 ~ 0.6 0 0.6 0 20
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 1 at @s run particle poof ^0.675 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 2 at @s run particle poof ^0.225 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 3 at @s run particle poof ^-0.225 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 4 at @s run particle poof ^-0.675 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=up,tag=!too_expensive,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 5 at @s run particle poof ^ ^0.15 ^1.5 0.25 0.1 0.25 0.03 20

execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches -1 at @s run particle minecraft:smoke ~ ~0.1 ~ 0.6 0 0.6 0.05 30
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 0 at @s run particle block lime_terracotta ^0.675 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 1 at @s run particle block lime_terracotta ^0.225 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 2 at @s run particle block lime_terracotta ^-0.225 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 3 at @s run particle block lime_terracotta ^-0.675 ^0.15 ^1.5 0.1 0.1 0.1 0.03 12
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!no_building,tag=!quit_management,tag=down,tag=entity_selected] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s property_state matches 4 at @s run particle poof ^ ^0.15 ^1.5 0.25 0.1 0.25 0.03 20

execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=too_expensive,tag=entity_selected] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 1.5 0.7
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=too_expensive,tag=entity_selected] run scoreboard players set no_funds timer 20

execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=no_building,tag=entity_selected] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 1.5 0.7
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=no_building,tag=!hotel,tag=entity_selected] run scoreboard players set no_houses timer 20
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=no_building,tag=down,tag=hotel,tag=entity_selected] run scoreboard players set no_houses timer 20
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=no_building,tag=up,tag=hotel,tag=entity_selected] run scoreboard players set no_hotels timer 20

execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=quit_management,tag=entity_selected] run scoreboard players operation turn_state game_state = previous_turn_state game_state
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=quit_management,tag=entity_selected] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:block.piston.contract master @s ~ ~1 ~ 0.5 1.3
execute unless score auction_id space_id matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=quit_management,tag=entity_selected] run kill @e[tag=p_manage_entity]

execute unless score auction_id space_id matches 1.. unless entity @e[type=interaction,tag=p_manage_entity,tag=too_expensive,tag=entity_selected] unless entity @e[type=interaction,tag=p_manage_entity,tag=no_building,tag=entity_selected] run function monopoly:board/update_property_visuals
execute unless score auction_id space_id matches 1.. if entity @e[type=interaction,tag=p_manage_entity,tag=!quit_management,tag=!too_expensive,tag=!no_building,tag=entity_selected] run function monopoly:board/property_management_entities

tag @e[tag=entity_selected] remove entity_selected

scoreboard players reset house_count_temp constants
scoreboard players reset hotel_count_temp constants
