
execute as @e[tag=token,scores={payment=1..,payment_to=1..},tag=!paying] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = @e[tag=token,scores={payment=1..,payment_to=1..},tag=!paying,sort=nearest,limit=1] payment_to run scoreboard players operation @s payment -= @e[tag=token,scores={payment=1..,payment_to=1..},tag=!paying,sort=nearest,limit=1] payment
execute if score player_count_minus_one constants matches 1.. as @e[tag=token,scores={payment=1..,payment_to=7},tag=!paying] at @s as @e[tag=token,scores={player_id=1..}] unless score @s player_id = @e[tag=token,scores={payment=1..,payment_to=7},tag=!paying,sort=nearest,limit=1] player_id run scoreboard players operation @s payment -= @e[tag=token,scores={payment=1..,payment_to=1..},tag=!paying,sort=nearest,limit=1] payment
execute if score player_count_minus_one constants matches 1.. as @e[tag=token,scores={payment=1..,payment_to=7},tag=!paying] at @s as @e[tag=token,scores={player_id=1..}] unless score @s player_id = @e[tag=token,scores={payment=1..,payment_to=7},tag=!paying,sort=nearest,limit=1] player_id run scoreboard players operation @s payment /= player_count_minus_one constants

execute as @e[tag=token,scores={payment=1..,payment_to=8}] run scoreboard players operation free_parking money += @s payment
execute as @e[tag=token,scores={payment=1..,payment_to=8}] run function monopoly:board/free_parking_money_visual

execute as @e[tag=token,tag=!paying,scores={payment=1..}] at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,tag=!paying,scores={payment=1..},sort=nearest,limit=1] player_id run scoreboard players operation @s payment = @e[tag=token,tag=!paying,scores={payment=1..},sort=nearest,limit=1] payment
execute as @e[tag=token,tag=!paying,scores={payment=..-1}] at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,tag=!paying,scores={payment=..-1},sort=nearest,limit=1] player_id run scoreboard players operation @s payment = @e[tag=token,tag=!paying,scores={payment=..-1},sort=nearest,limit=1] payment
execute as @e[tag=token,tag=!paying,scores={payment=1..}] at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,tag=!paying,scores={payment=1..},sort=nearest,limit=1] player_id run scoreboard players operation @s payment_to = @e[tag=token,tag=!paying,scores={payment=1..},sort=nearest,limit=1] payment_to
execute as @e[tag=token,tag=!paying,scores={payment=..-1}] at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,tag=!paying,scores={payment=..-1},sort=nearest,limit=1] player_id run scoreboard players operation @s payment_to = @e[tag=token,tag=!paying,scores={payment=..-1},sort=nearest,limit=1] payment_to



tag @e[scores={payment=..-1}] add reverse_payment_number
scoreboard players operation @e[tag=reverse_payment_number] payment *= negative_one constants

execute as @e[scores={payment=1..},tag=!reverse_payment_number,tag=!paying,tag=msg_sys_entity] unless entity @e[tag=token,scores={payment_to=1..7}] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" paid ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"italic":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"},"color":"aqua","italic":true},{"text":" to the bank.","color":"gray","italic":true}] 
execute as @e[scores={payment=1..},tag=reverse_payment_number,tag=!paying,tag=msg_sys_entity] unless entity @e[tag=token,scores={payment_to=1..7}] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" received ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"italic":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"},"color":"aqua","italic":true},{"text":" from the bank.","color":"gray","italic":true}] 
execute as @e[scores={payment=1..,payment_to=1..6},tag=!reverse_payment_number,tag=!paying,tag=msg_sys_entity] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" paid ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"italic":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"},"color":"aqua","italic":true},{"text":" to ","color":"gray","italic":true},{"selector":"@e[limit=1,tag=reverse_payment_number,tag=msg_sys_entity]","italic":true},{"text":".","color":"gray","italic":true}] 
execute as @e[scores={payment=1..,payment_to=7},tag=!reverse_payment_number,tag=!paying,tag=msg_sys_entity] at @s run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" paid ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"italic":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"},"color":"aqua","italic":true},{"text":" divided between: ","color":"gray","italic":true,"extra":[{"selector":"@e[tag=msg_sys_entity,distance=0.01..]"}]},{"text":".","color":"gray","italic":true}] 

scoreboard players reset @e[tag=token,scores={payment=1..,payment_to=1..},tag=!paying] payment_to

scoreboard players operation @e[tag=reverse_payment_number] payment *= negative_one constants
tag @e[tag=reverse_payment_number] remove reverse_payment_number


tag @e[tag=token,scores={payment=1..},tag=!paying] add paying
tag @e[tag=token,scores={payment=..-1},tag=!paying] add paying



execute as @a[scores={payment=1..}] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 1 0.65
execute as @a[scores={payment=1..}] at @s run playsound minecraft:entity.item.pickup master @s ~ ~1 ~ 0.2 1.5
title @a[scores={payment=1..},tag=!hide_money_text] times 0 30 5 
title @a[scores={payment=1..},tag=!hide_money_text] title ""
execute as @a[scores={payment=1..},tag=!hide_money_text] run title @s subtitle {"text":"-","color":"red","extra":[{"text":"D","color":"dark_red","bold":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"}}]}

execute as @a[scores={payment=..-1}] at @s as @a run playsound minecraft:entity.player.levelup player @s ~ ~1 ~ 0.2 1.5
title @a[scores={payment=..-1}] times 0 30 5
title @a[scores={payment=..-1}] title ""
tag @a[scores={payment=..-1}] add reverse_payment_number
scoreboard players operation @a[tag=reverse_payment_number] payment *= negative_one constants
execute as @a[tag=reverse_payment_number] run title @s subtitle {"text":"+","color":"green","extra":[{"text":"D","color":"dark_green","bold":true,"strikethrough":true},{"score":{"name":"@s","objective":"payment"}}]}
scoreboard players operation @a[tag=reverse_payment_number] payment *= negative_one constants
tag @a[tag=reverse_payment_number] remove reverse_payment_number

execute if entity @e[tag=token,tag=paying] as @a at @s run playsound minecraft:block.amethyst_block.resonate master @s ~ ~1 ~ 0.5 2
execute if entity @e[tag=token,tag=paying] as @a at @s run playsound minecraft:entity.item.pickup master @s ~ ~1 ~ 0.1 2

scoreboard players remove @e[tag=token,scores={payment=1..5}] money 1
scoreboard players remove @e[tag=token,scores={payment=1..5}] payment 1
scoreboard players remove @e[tag=token,scores={payment=6..10}] money 5
scoreboard players remove @e[tag=token,scores={payment=6..10}] payment 5
scoreboard players remove @e[tag=token,scores={payment=11..20}] money 10
scoreboard players remove @e[tag=token,scores={payment=11..20}] payment 10
scoreboard players remove @e[tag=token,scores={payment=21..50}] money 20
scoreboard players remove @e[tag=token,scores={payment=21..50}] payment 20
scoreboard players remove @e[tag=token,scores={payment=51..100}] money 50
scoreboard players remove @e[tag=token,scores={payment=51..100}] payment 50
scoreboard players remove @e[tag=token,scores={payment=101..500}] money 100
scoreboard players remove @e[tag=token,scores={payment=101..500}] payment 100
scoreboard players remove @e[tag=token,scores={payment=501..}] money 500
scoreboard players remove @e[tag=token,scores={payment=501..}] payment 500

scoreboard players add @e[tag=token,scores={payment=-5..-1}] money 1
scoreboard players add @e[tag=token,scores={payment=-5..-1}] payment 1
scoreboard players add @e[tag=token,scores={payment=-10..-6}] money 5
scoreboard players add @e[tag=token,scores={payment=-10..-6}] payment 5
scoreboard players add @e[tag=token,scores={payment=-20..-11}] money 10
scoreboard players add @e[tag=token,scores={payment=-20..-11}] payment 10
scoreboard players add @e[tag=token,scores={payment=-50..-21}] money 20
scoreboard players add @e[tag=token,scores={payment=-50..-21}] payment 20
scoreboard players add @e[tag=token,scores={payment=-100..-51}] money 50
scoreboard players add @e[tag=token,scores={payment=-100..-51}] payment 50
scoreboard players add @e[tag=token,scores={payment=-500..-101}] money 100
scoreboard players add @e[tag=token,scores={payment=-500..-101}] payment 100
scoreboard players add @e[tag=token,scores={payment=..-501}] money 500
scoreboard players add @e[tag=token,scores={payment=..-501}] payment 500

scoreboard players reset @e[tag=!token] payment
scoreboard players reset @e[scores={payment=0}] payment
execute as @e[tag=paying] unless score @s payment matches 1.. unless score @s payment matches ..-1 run tag @s remove paying