scoreboard players set turn_state game_state 1

execute as @e[tag=token] if score @s player_id = current_turn player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,sort=nearest,limit=1] space_id run tag @s add space_landed
scoreboard players set action_delay timer 8

execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 1..19 unless score @s space_id matches 21..29 unless score @s space_id matches 31..39 at @s run particle minecraft:happy_villager ~1.9 ~0.1 ~ 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 1..19 unless score @s space_id matches 21..29 unless score @s space_id matches 31..39 at @s run particle minecraft:happy_villager ~-1.9 ~0.1 ~ 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 1..19 unless score @s space_id matches 21..29 unless score @s space_id matches 31..39 at @s run particle minecraft:happy_villager ~ ~0.1 ~1.9 0.9 0 0.1 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 1..19 unless score @s space_id matches 21..29 unless score @s space_id matches 31..39 at @s run particle minecraft:happy_villager ~ ~0.1 ~-1.9 0.9 0 0.1 0 20 force

execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 10..20 unless score @s space_id matches 30..39 at @s run particle minecraft:happy_villager ~1.9 ~0.1 ~ 0.1 0 0.45 0 10 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 10..20 unless score @s space_id matches 30..39 at @s run particle minecraft:happy_villager ~-1.9 ~0.1 ~ 0.1 0 0.45 0 10 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 10..20 unless score @s space_id matches 30..39 at @s run particle minecraft:happy_villager ~ ~0.1 ~0.9 0.9 0 0.1 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 10..20 unless score @s space_id matches 30..39 at @s run particle minecraft:happy_villager ~ ~0.1 ~-0.9 0.9 0 0.1 0 20 force

execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 0..10 unless score @s space_id matches 20..30 at @s run particle minecraft:happy_villager ~0.9 ~0.1 ~ 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 0..10 unless score @s space_id matches 20..30 at @s run particle minecraft:happy_villager ~-0.9 ~0.1 ~ 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 0..10 unless score @s space_id matches 20..30 at @s run particle minecraft:happy_villager ~ ~0.1 ~1.9 0.45 0 0.1 0 10 force
execute as @e[type=marker,tag=space,tag=space_landed] unless score @s space_id matches 0 unless score @s space_id matches 0..10 unless score @s space_id matches 20..30 at @s run particle minecraft:happy_villager ~ ~0.1 ~-1.9 0.45 0 0.1 0 10 force

execute as @e[type=marker,tag=space,tag=space_landed,scores={space_id=10}] at @s run particle minecraft:happy_villager ~0.4 ~0.1 ~-1.5 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_id=10}] at @s run particle minecraft:happy_villager ~-3.4 ~0.1 ~-1.5 0.1 0 0.9 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_id=10}] at @s run particle minecraft:happy_villager ~-1.5 ~0.1 ~0.4 0.9 0 0.1 0 20 force
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_id=10}] at @s run particle minecraft:happy_villager ~-1.5 ~0.1 ~-3.4 0.9 0 0.1 0 20 force

execute as @e[type=marker,tag=space,tag=space_landed] at @s run playsound minecraft:block.note_block.harp block @s ~ ~ ~ 0.3 2 0.1
execute as @e[type=marker,tag=space,tag=space_landed] at @s run playsound minecraft:entity.player.levelup block @s ~ ~ ~ 0.3 1.6 0.1


function monopoly:system/update_message_targets
execute as @e[type=marker,tag=space,tag=space_landed] at @s as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" landed on ","color":"gray","italic":true},{"selector":"@e[type=marker,tag=space,sort=nearest,limit=1]","italic":true},{"text":".","color":"gray","italic":true}] 



execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=0}] run function monopoly:money/go_money
execute if score double_go_rule game_state matches 1.. if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=0}] as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id run scoreboard players remove @s payment 200

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..10,property_state=-2}] as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless entity @s[tag=go_property_wait] run scoreboard players set turn_state game_state 7
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..10,property_state=-2}] as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless entity @s[tag=go_property_wait] run scoreboard players operation @s buy_cost = @e[type=marker,tag=space,tag=space_landed,limit=1] buy_cost


execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=0},tag=!monopoly] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_base
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=0},tag=monopoly] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_0
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=1}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_1
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=2}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_2
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=3}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_3
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=4}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_4
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..8,property_state=5..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending = @e[type=marker,tag=space,tag=space_landed,limit=1] rent_5
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=9,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players set @s payment_pending 25
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=9,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id at @s as @e[type=marker,tag=space,tag=!space_landed,scores={space_type=9}] if score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] payment_pending *= two constants
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=9,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..},tag=pay_double] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending *= two constants
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players set @s payment_pending 4
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..},tag=pay_double] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players set @s payment_pending 10
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id at @s as @e[type=marker,tag=space,tag=!space_landed,scores={space_type=10}] if score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players set @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] payment_pending 10
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_pending *= @s roll


execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run tag @s add moving_token
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..},tag=moving_token] unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players set turn_state game_state 10
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=1..10,property_state=0..}] at @s as @e[tag=token,scores={player_id=1..},tag=moving_token] unless score @s player_id = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id run scoreboard players operation @s payment_to = @e[type=marker,tag=space,tag=space_landed,limit=1] player_id
tag @e[tag=moving_token] remove moving_token

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11..12}] run scoreboard players set turn_state game_state -1
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11..12}] as @a at @s run playsound minecraft:block.beacon.power_select block @s ~ ~ ~ 0.7 2 0.2
execute as @e[type=marker,tag=space,tag=space_landed,scores={space_type=11..12}] at @s run tag @e[type=interaction,tag=chest_hitbox,sort=nearest,limit=1] add active
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=mooshroom] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:16733525}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=cat] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:16755200}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=frog] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:5635925}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=goat] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:5636095}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=axolotl] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:5592575}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[tag=token,scores={player_id=1..},team=pig] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {glow_color_override:16733695}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=chance,sort=nearest,limit=1] {Glowing:1b}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=mooshroom] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:16733525}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=cat] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:16755200}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=frog] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:5635925}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=goat] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:5636095}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=axolotl] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:5592575}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[tag=token,scores={player_id=1..},team=pig] if score @s player_id = current_turn player_id as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {glow_color_override:16733695}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run data merge entity @e[type=block_display,tag=board_icon,tag=community_chest,sort=nearest,limit=1] {Glowing:1b}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run summon minecraft:text_display ~ ~1.35 ~ {Tags:["open_chest_text","board_icon"],text:'{"text":"Right Click","color":"yellow","bold":true,"extra":[{"text":" to Draw Card","color":"gold","bold":false}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},billboard:"center",line_width:70,shadow:1b,background:0}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run summon minecraft:text_display ~ ~1.35 ~ {Tags:["open_chest_text","board_icon"],text:'{"text":"Right Click","color":"aqua","bold":true,"extra":[{"text":" to Draw Card","color":"dark_aqua","bold":false}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},billboard:"center",line_width:70,shadow:1b,background:0}
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=11}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run playsound minecraft:block.piston.extend block @s ~ ~ ~ 0.3 2
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=12}] as @e[type=interaction,tag=chest_hitbox,tag=active] at @s run playsound minecraft:block.iron_door.open block @s ~ ~ ~ 1.2 1.8

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=14}] if score free_parking money matches 1.. if score free_parking_rule game_state matches 1.. run function monopoly:money/free_parking_money

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=15}] run function monopoly:movement/send_current_token_to_jail

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=16}] as @e[tag=token] if score @s player_id = current_turn player_id run scoreboard players add @s payment_pending 200
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=16}] as @e[tag=token] if score @s player_id = current_turn player_id run scoreboard players set @s payment_to 8
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=16}] run scoreboard players set turn_state game_state 10

execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=17}] as @e[tag=token] if score @s player_id = current_turn player_id run scoreboard players add @s payment_pending 100
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=17}] as @e[tag=token] if score @s player_id = current_turn player_id run scoreboard players set @s payment_to 8
execute if entity @e[type=marker,tag=space,tag=space_landed,scores={space_type=17}] run scoreboard players set turn_state game_state 10



tag @e[type=marker,tag=space,tag=space_landed] remove space_landed







# Space IDs

# 0 		GO
# 1 - 8		Colour Spaces
# 9			Railroad
# 10 		Utility
# 11 		Chance
# 12 		Community Chest
# 13 		Jail
# 14		Free Parking
# 15 		Go to Jail
# 16 		Income Tax
# 17 		Luxury Tax


# Property State IDs

# -2 		BANK OWNED
# -1		MORTGAGED
# 0			0 HOUSES
# 1			1 HOUSE
# 2			2 HOUSES
# 3			3 HOUSES
# 4			4 HOUSES
# 5			HOTEL