
scoreboard players set action_delay timer 8
function monopoly:system/update_message_targets
tag @a[scores={player_id=1..}] add update_inventory
execute as @e[type=interaction,tag=p_trade_entity] at @s on target if score @s player_id = current_controller player_id run tag @e[type=interaction,tag=p_trade_entity,sort=nearest,limit=1] add entity_selected


execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score counter_offer game_state matches 1.. run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_controller,limit=1]","italic":true},{"text":" proposed a counter offer.","color":"gray","italic":true}] 
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id unless score counter_offer game_state matches 1.. run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_turn,limit=1]","italic":true},{"text":" proposed a trade to ","color":"gray","italic":true},{"selector":"@s","italic":true},{"text":".","color":"gray","italic":false}] 


execute as @e[type=interaction,tag=p_trade_entity,tag=!down_money,tag=!cancel,tag=!revoke,tag=entity_selected] at @s run particle minecraft:composter ~ ~0.3 ~ 0.2 0.2 0.2 0 20
execute as @e[type=interaction,tag=p_trade_entity,tag=revoke,tag=entity_selected] at @s run particle minecraft:smoke ~ ~0.3 ~ 0.2 0.2 0.2 0 20
execute as @e[type=interaction,tag=p_trade_entity,tag=down_money,tag=entity_selected] at @s run particle minecraft:smoke ~ ~0.3 ~ 0.2 0.2 0.2 0 20

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players set turn_state game_state 8
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players operation trade_target_temp player_id = trade_target player_id
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players operation trade_target player_id = current_controller player_id
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players operation current_controller player_id = trade_target_temp player_id
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players reset trade_target_temp player_id
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run scoreboard players set counter_offer game_state 1
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id at @s run playsound minecraft:entity.player.levelup master @a ~ ~1 ~ 1 0.8
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:entity.player.levelup master @a ~ ~1 ~ 1 0.8
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s times 0 30 20
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s title ""
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = trade_target player_id run title @s subtitle {"text":"Trade Offer!","underlined":true,"color":"aqua","bold":true}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s times 0 30 20
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s title ""

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s subtitle {"text":"Trade Offer!","underlined":true,"color":"aqua","bold":true}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=marker,tag=space,tag=!trading] at @s run data merge entity @e[type=item_display,tag=player_head,tag=property_status,tag=board_icon,distance=..3,sort=nearest,limit=1] {Glowing:0b}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=marker,tag=space,tag=trading] if score @s player_id = trade_target player_id at @s run data merge entity @e[type=item_display,tag=player_head,tag=property_status,tag=board_icon,distance=..3,sort=nearest,limit=1] {glow_color_override:5635925}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=marker,tag=space,tag=trading] if score @s player_id = current_controller player_id at @s run data merge entity @e[type=item_display,tag=player_head,tag=property_status,tag=board_icon,distance=..3,sort=nearest,limit=1] {glow_color_override:16733525}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] unless score offering_chance game_state matches 1.. run data merge entity @e[type=item_display,tag=jail_card_chance_owner,tag=p_trade_entity,limit=1] {Glowing:0b}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] unless score offering_community_chest game_state matches 1.. run data merge entity @e[type=item_display,tag=jail_card_community_chest_owner,tag=p_trade_entity,limit=1] {Glowing:0b}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score offering_chance game_state matches 1.. if score jail_card_chance player_id = trade_target player_id run data merge entity @e[type=item_display,tag=jail_card_chance_owner,tag=p_trade_entity,limit=1] {glow_color_override:5635925}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score offering_chance game_state matches 1.. if score jail_card_chance player_id = current_controller player_id run data merge entity @e[type=item_display,tag=jail_card_chance_owner,tag=p_trade_entity,limit=1] {glow_color_override:16733525}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score offering_community_chest game_state matches 1.. if score jail_card_community_chest player_id = trade_target player_id run data merge entity @e[type=item_display,tag=jail_card_community_chest_owner,tag=p_trade_entity,limit=1] {glow_color_override:5635925}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score offering_community_chest game_state matches 1.. if score jail_card_community_chest player_id = current_controller player_id run data merge entity @e[type=item_display,tag=jail_card_community_chest_owner,tag=p_trade_entity,limit=1] {glow_color_override:16733525}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run team join positive_entity @e[type=armor_stand,tag=p_trade_entity,tag=red,tag=hitbox_display_icon]
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run team join negative_entity @e[type=armor_stand,tag=p_trade_entity,tag=green,tag=hitbox_display_icon]
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=armor_stand,tag=p_trade_entity,tag=red,tag=hitbox_display_icon] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:emerald_block",Count:1b}]}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=armor_stand,tag=p_trade_entity,tag=green,tag=hitbox_display_icon] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:redstone_block",Count:1b}]}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] as @e[type=item_display,tag=p_trade_entity,tag=trade_offer_stay,tag=trade_money_target] at @s run tp @s ~ ~0.4 ~
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score trade_amount money matches 1.. if score trade_money player_id = current_controller player_id run summon text_display 10.0 101.6 -10.0 {Tags:["p_trade_entity","trade_offer_stay"],text:'[{"text":"Amount Requested ","color":"red"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"score":{"name":"trade_amount","objective":"money"},"color":"aqua"}]',line_width:90,transformation:{right_rotation:[0f,0f,0f,1f],scale:[1.5f,1.5f,1.5f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,billboard:"center",shadow:1b,background:0}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score trade_amount money matches 1.. if score trade_money player_id = trade_target player_id run summon text_display 10.0 101.6 -10.0 {Tags:["p_trade_entity","trade_offer_stay"],text:'[{"text":"Amount Offered ","color":"green"},{"text":"D","bold":true,"strikethrough":true,"color":"dark_aqua"},{"score":{"name":"trade_amount","objective":"money"},"color":"aqua"}]',line_width:85,transformation:{right_rotation:[0f,0f,0f,1f],scale:[1.5f,1.5f,1.5f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,billboard:"center",shadow:1b,background:0}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] unless score trade_amount money matches 1.. run kill @e[type=item_display,tag=p_trade_entity,tag=trade_money_target]

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score trade_money player_id = current_controller player_id run data merge entity @e[type=item_display,tag=p_trade_entity,tag=trade_offer_stay,tag=trade_money_target,limit=1] {glow_color_override:16733525}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] if score trade_money player_id = trade_target player_id run data merge entity @e[type=item_display,tag=p_trade_entity,tag=trade_offer_stay,tag=trade_money_target,limit=1] {glow_color_override:5635925}
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run kill @e[tag=p_trade_entity,tag=!trade_offer_stay]


execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=offer] at @s run playsound minecraft:entity.experience_orb.pickup master @a ~ ~0.3 ~ 0.35 1.3
execute as @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=up_money] at @s run playsound minecraft:entity.experience_orb.pickup master @a ~ ~0.3 ~ 0.35 1.6
execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=revoke] at @s run playsound minecraft:block.note_block.bass master @a ~ ~0.3 ~ 2 1.3
execute as @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=down_money] at @s run playsound minecraft:block.note_block.bass master @a ~ ~0.3 ~ 2 1.6

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=down_money,tag=100] run scoreboard players remove trade_amount money 100
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=down_money,tag=10] run scoreboard players remove trade_amount money 10
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=down_money,tag=1] run scoreboard players remove trade_amount money 1
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=up_money,tag=1] run scoreboard players add trade_amount money 1
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=up_money,tag=10] run scoreboard players add trade_amount money 10
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=up_money,tag=100] run scoreboard players add trade_amount money 100

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=toggle_payer] if score trade_money player_id = current_controller player_id run scoreboard players set trade_money player_id 0
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=toggle_payer] unless score trade_money player_id = current_controller player_id unless score trade_money player_id matches 0 run scoreboard players operation trade_money player_id = current_controller player_id
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=toggle_payer] if score trade_money player_id matches 0 run scoreboard players operation trade_money player_id = trade_target player_id

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=toggle_payer] run playsound minecraft:entity.illusioner.mirror_move block @a 10.0 102.67 -10.0 0.5 2

execute if score trade_amount money matches ..-1 run scoreboard players set trade_amount money 0
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = trade_money player_id if score @s money < trade_amount money run scoreboard players operation trade_amount money = @s money

execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=!chance_card,tag=!community_chest_card] at @s as @e[type=marker,tag=space,sort=nearest,limit=1,scores={player_id=1..}] if entity @s[tag=trading] run tag @s add remove_trading
execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=!chance_card,tag=!community_chest_card] at @s as @e[type=marker,tag=space,sort=nearest,limit=1,scores={player_id=1..}] if entity @s[tag=!trading] run tag @s add trading
tag @e[tag=remove_trading] remove trading
tag @e[tag=remove_trading] remove remove_trading

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run tag @a add update_inventory
execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=confirm] run tag @a add disable_inventory_checks

execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=chance_card] run scoreboard players add offering_chance game_state 1
execute if score offering_chance game_state matches 2.. run scoreboard players reset offering_chance game_state
execute as @e[type=interaction,tag=p_trade_entity,tag=toggle_trade,tag=entity_selected,tag=community_chest_card] run scoreboard players add offering_community_chest game_state 1
execute if score offering_community_chest game_state matches 2.. run scoreboard players reset offering_community_chest game_state

execute as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.5

execute if entity @e[type=interaction,tag=p_trade_entity,tag=entity_selected,tag=cancel] if score counter_offer game_state matches 1.. run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_controller,limit=1]","italic":true},{"text":" declined the trade offer.","color":"gray","italic":true}] 
execute if entity @e[type=interaction,tag=p_trade_entity,tag=cancel,tag=entity_selected] run function monopoly:trade/cancel_trade
execute if entity @e[type=interaction,tag=p_trade_entity,tag=!cancel,tag=!confirm,tag=entity_selected] run function monopoly:trade/trade_entities

tag @e[tag=entity_selected] remove entity_selected
