difficulty easy
execute as @e[name=CanadianHybrid] at @s run particle minecraft:dust_color_transition 1 0 0 1 1 0.2 0.2 ~ ~1 ~ 0.24 0.48 0.24 1 1 normal @a[distance=0.001..]
execute as @a unless score @s disconnect matches 0.. run gamemode adventure @s
gamemode adventure @a[gamemode=survival]
execute as @a unless score @s disconnect matches 0.. run tp @s 0.0 100 0.0 45 0
execute as @a unless score @s disconnect matches 0.. run scoreboard players set @s disconnect 1
scoreboard players reset @a[scores={disconnect=1..}] crouch_id
execute as @a[scores={disconnect=1..}] unless score start_animation timer matches 1.. if score game_pending game_state matches 1 run team leave @s
execute as @a[scores={disconnect=1..}] unless score start_animation timer matches 1.. if score game_pending game_state matches 1.. run function monopoly:setup/update_selection_token_visuals
execute as @a[scores={disconnect=1..}] unless score start_animation timer matches 1.. if score game_pending game_state matches 1 run scoreboard players reset @s player_id
tag @a[scores={disconnect=1..}] add disable_inventory_checks
tag @a[scores={disconnect=1..}] add update_inventory
scoreboard players set @a[scores={disconnect=1..}] disconnect 0
team join spectator @a[team=]

execute unless score scoreboard_valid constants matches 1.. run function monopoly:system/reset_game
execute as @a unless score @s crouch_id matches 1.. run tag @s add needs_crouch_id
execute as @a unless score @s crouch_id matches 1.. run gamemode adventure @s
scoreboard players set @a[tag=needs_crouch_id,limit=1] crouch_id 0
tag @a[tag=needs_crouch_id] remove needs_crouch_id

execute if entity @a[scores={crouch_id=0}] run scoreboard players add @e[scores={crouch_id=0..}] crouch_id 1

kill @e[type=item,tag=!do_not_kill]
execute as @a at @s positioned ~ -64 ~ run tp @s[dy=140] 0.0 100 0.0
scoreboard players set player_teams_occupied constants 0
execute as @a[team=!spectator] run scoreboard players add player_teams_occupied constants 1
execute unless score game_pending game_state matches 1.. run scoreboard players reset player_count constants
execute unless score game_pending game_state matches 1.. as @e[tag=token,scores={player_id=1..}] run scoreboard players add player_count constants 1
scoreboard players operation player_count_minus_one constants = player_count constants
scoreboard players remove player_count_minus_one constants 1
scoreboard players set house_count constants 32
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=1..4}] run scoreboard players operation house_count constants -= @s property_state
execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] run scoreboard players operation house_count constants -= @s extra_houses
scoreboard players set hotel_count constants 12
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=5..}] run scoreboard players remove hotel_count constants 1
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] run scoreboard players operation house_count constants -= @s extra_hotels

execute unless score start_animation timer matches 1.. if score game_pending game_state matches 1.. if score player_teams_occupied constants < player_teams_occupied_prev constants run function monopoly:setup/update_selection_token_visuals
scoreboard players operation player_teams_occupied_prev constants = player_teams_occupied constants

# Token Selection System

execute as @e[type=minecraft:interaction,tag=p_token_entity,nbt={interaction:{}}] unless score @s timer matches 1.. run tag @s add token_hitbox_interacted
execute as @e[type=minecraft:interaction,tag=p_token_entity,tag=token_hitbox_interacted] run function monopoly:setup/select_token
tag @e[tag=token_hitbox_interacted] remove token_hitbox_interacted

execute if score start_animation timer matches 1.. run function monopoly:setup/update_start_animation


execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 2.. run team join positive_entity @e[type=armor_stand,tag=hitbox_display_icon,tag=start_game]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 2.. run tag @e[type=interaction,tag=p_token_entity,tag=start_game,tag=!active] add active
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 2.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=start_game] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:emerald_block",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 2.. as @e[type=text_display,tag=p_token_entity,tag=start_text] run data merge entity @s {text:'{"text":"Start Game","color":"green","bold":true}'}

execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score player_teams_occupied constants matches 2.. run team join neutral_entity @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=start_game]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score player_teams_occupied constants matches 2.. run tag @e[type=interaction,tag=p_token_entity,tag=start_game,tag=active] remove active
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score player_teams_occupied constants matches 2.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=start_game] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:coal_block",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score player_teams_occupied constants matches 2.. as @e[type=text_display,tag=p_token_entity,tag=start_text] run data merge entity @s {text:'{"text":"Start Game","color":"dark_gray","bold":true}'}


execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score free_parking_rule game_state matches 1.. run team join positive_entity @e[type=armor_stand,tag=hitbox_display_icon,tag=free_parking]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score free_parking_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=free_parking] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score free_parking_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=free_parking] run data merge entity @s {text:'{"text":"ON","color":"green","bold":true}'}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score free_parking_rule game_state matches 1.. run team join negative_entity @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=free_parking]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score free_parking_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=free_parking] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score free_parking_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=free_parking] run data merge entity @s {text:'{"text":"OFF","color":"red","bold":true}'}

execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score ones_rule game_state matches 1.. run team join positive_entity @e[type=armor_stand,tag=hitbox_display_icon,tag=snake_eyes]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score ones_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=snake_eyes] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score ones_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=snake_eyes] run data merge entity @s {text:'{"text":"ON","color":"green","bold":true}'}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score ones_rule game_state matches 1.. run team join negative_entity @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=snake_eyes]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score ones_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=snake_eyes] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score ones_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=snake_eyes] run data merge entity @s {text:'{"text":"OFF","color":"red","bold":true}'}

execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score go_property_rule game_state matches 1.. run team join positive_entity @e[type=armor_stand,tag=hitbox_display_icon,tag=around_the_board]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score go_property_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=around_the_board] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score go_property_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=around_the_board] run data merge entity @s {text:'{"text":"ON","color":"green","bold":true}'}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score go_property_rule game_state matches 1.. run team join negative_entity @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=around_the_board]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score go_property_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=around_the_board] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score go_property_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=around_the_board] run data merge entity @s {text:'{"text":"OFF","color":"red","bold":true}'}

execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score double_go_rule game_state matches 1.. run team join positive_entity @e[type=armor_stand,tag=hitbox_display_icon,tag=double_go]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score double_go_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=double_go] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. if score double_go_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=double_go] run data merge entity @s {text:'{"text":"ON","color":"green","bold":true}'}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score double_go_rule game_state matches 1.. run team join negative_entity @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=double_go]
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score double_go_rule game_state matches 1.. as @e[type=armor_stand,tag=p_token_entity,tag=hitbox_display_icon,tag=double_go] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}]}
execute if score game_pending game_state matches 1.. unless score start_animation timer matches 1.. unless score double_go_rule game_state matches 1.. as @e[type=text_display,tag=p_token_entity,tag=gamerule_status,tag=double_go] run data merge entity @s {text:'{"text":"OFF","color":"red","bold":true}'}




# Random thing to help if tokens bundle

execute as @e[tag=token,team=mooshroom] at @s if entity @e[tag=token,team=!mooshroom,distance=..0.005] run tp @s ~0.01 ~ ~0.01
execute as @e[tag=token,team=cat] at @s if entity @e[tag=token,team=!cat,distance=..0.005] run tp @s ~-0.01 ~ ~0.01
execute as @e[tag=token,team=frog] at @s if entity @e[tag=token,team=!frog,distance=..0.005] run tp @s ~0.01 ~ ~-0.01
execute as @e[tag=token,team=goat] at @s if entity @e[tag=token,team=!goat,distance=..0.005] run tp @s ~-0.01 ~ ~-0.01
execute as @e[tag=token,team=axolotl] at @s if entity @e[tag=token,team=!axolotl,distance=..0.005] run tp @s ~0.005 ~ ~-0.01
execute as @e[tag=token,team=pig] at @s if entity @e[tag=token,team=!pig,distance=..0.005] run tp @s ~-0.01 ~ ~-0.005



# Player registration handler

execute if score game_pending game_state matches 1.. run scoreboard players set next_turn_override timer 60
execute unless score next_turn_override timer matches 0.. run scoreboard players set next_turn_override timer 60
execute if score next_turn_override timer matches 1.. run scoreboard players remove next_turn_override timer 1
execute if score auction_id space_id matches 1.. if score next_turn_override timer matches 1.. run scoreboard players set next_turn_override timer 60
execute if entity @e[tag=token,scores={player_id=1..}] if score next_turn_override timer matches ..0 unless score game_pending game_state matches 1.. run function monopoly:system/progress_turn_order
execute if entity @e[tag=token,scores={player_id=1..}] if score next_turn_override timer matches ..0 unless score game_pending game_state matches 1.. run scoreboard players reset next_turn_override timer
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_turn player_id run scoreboard players reset next_turn_override timer

execute unless score game_id game_state matches 1.. run scoreboard players set game_id game_state 1
execute as @a[scores={player_id=1..}] unless score @s game_state = game_id game_state run team leave @s
execute as @a[scores={player_id=1..}] unless score @s game_state = game_id game_state run scoreboard players reset @s player_id
execute as @a unless score @s game_state = game_id game_state run scoreboard players operation @s game_state = game_id game_state



execute unless score game_pending game_state matches 1.. run tag @a[scores={player_id=1..}] add reset_player_id
execute as @e[tag=token,scores={player_id=1..}] at @s as @a[tag=reset_player_id] if score @s player_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] player_id run tag @s remove reset_player_id
scoreboard players reset @a[tag=reset_player_id] player_id
tag @a[tag=reset_player_id] remove reset_player_id

execute as @a[tag=registered_player] unless score @s player_id matches 1.. run tag @s remove registered_player
execute unless score game_pending game_state matches 1.. as @a[team=!spectator] unless score @s player_id matches 1..6 run team leave @s
execute as @e[tag=token,team=mooshroom] at @s as @a[team=!mooshroom_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=mooshroom,sort=nearest,limit=1] player_id run team join mooshroom_player @s
execute as @e[tag=token,team=cat] at @s as @a[team=!cat_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=cat,sort=nearest,limit=1] player_id run team join cat_player @s
execute as @e[tag=token,team=frog] at @s as @a[team=!frog_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=frog,sort=nearest,limit=1] player_id run team join frog_player @s
execute as @e[tag=token,team=goat] at @s as @a[team=!goat_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=goat,sort=nearest,limit=1] player_id run team join goat_player @s
execute as @e[tag=token,team=axolotl] at @s as @a[team=!axolotl_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=axolotl,sort=nearest,limit=1] player_id run team join axolotl_player @s
execute as @e[tag=token,team=pig] at @s as @a[team=!pig_player,scores={player_id=1..}] if score @s player_id = @e[tag=token,team=pig,sort=nearest,limit=1] player_id run team join pig_player @s




# Random thing to help if tokens bundle

execute as @e[tag=token,team=mooshroom] at @s if entity @e[tag=token,team=!mooshroom,distance=..0.005] run tp @s ~0.01 ~ ~0.01
execute as @e[tag=token,team=cat] at @s if entity @e[tag=token,team=!cat,distance=..0.005] run tp @s ~-0.01 ~ ~0.01
execute as @e[tag=token,team=frog] at @s if entity @e[tag=token,team=!frog,distance=..0.005] run tp @s ~0.01 ~ ~-0.01
execute as @e[tag=token,team=goat] at @s if entity @e[tag=token,team=!goat,distance=..0.005] run tp @s ~-0.01 ~ ~-0.01
execute as @e[tag=token,team=axolotl] at @s if entity @e[tag=token,team=!axolotl,distance=..0.005] run tp @s ~0.005 ~ ~-0.01
execute as @e[tag=token,team=pig] at @s if entity @e[tag=token,team=!pig,distance=..0.005] run tp @s ~-0.01 ~ ~-0.005



# Dice and Movement

execute if entity @e[tag=token,scores={movement=-1..}] run function monopoly:movement/movement_update
execute if score dice_roll timer matches 1.. run function monopoly:dice/generate_random_dice

execute if entity @a[scores={payment=1..}] run function monopoly:money/receive_payment
execute if entity @a[scores={payment=..-1}] unless entity @a[scores={payment=1..}] run function monopoly:money/receive_payment


# Effect Management

effect give @a minecraft:saturation infinite 0 true
effect give @a minecraft:resistance infinite 4 true
execute as @a run attribute @s minecraft:generic.attack_damage base set 0


execute as @e[type=armor_stand,tag=hitbox_display_icon] at @s run tp @s ~ ~ ~ ~1 ~
execute as @e[type=interaction,tag=p_token_entity,tag=start_game,tag=active] at @s run particle composter ~ ~0.5 ~ 0.25 0.25 0.25 0 1

# Turn Progression

execute if score turn_state game_state matches 0 unless score game_pending game_state matches 1.. if entity @e[tag=token,scores={player_id=1..6}] run function monopoly:system/progress_turn_order


# Jail Card Management

execute if score jail_card_chance player_id matches 0.. if entity @e[type=marker,tag=chance_card,scores={card_id=1}] run kill @e[type=marker,tag=chance_card,scores={card_id=1}]
execute unless score jail_card_chance player_id matches 0.. unless entity @e[type=marker,tag=chance_card,scores={card_id=1}] run summon minecraft:marker 0.0 100 0.0 {Tags:["chance_card"]}
execute unless score jail_card_chance player_id matches 0.. as @e[type=marker,tag=chance_card] unless score @s card_id matches 0.. run scoreboard players set @s card_order 16
execute unless score jail_card_chance player_id matches 0.. as @e[type=marker,tag=chance_card] unless score @s card_id matches 0.. run scoreboard players set @s card_id 1
execute if score jail_card_community_chest player_id matches 0.. if entity @e[type=marker,tag=community_chest_card,scores={card_id=1}] run kill @e[type=marker,tag=community_chest_card,scores={card_id=1}]
execute unless score jail_card_community_chest player_id matches 0.. unless entity @e[type=marker,tag=community_chest_card,scores={card_id=1}] run summon minecraft:marker 0.0 100 0.0 {Tags:["community_chest_card"]}
execute unless score jail_card_community_chest player_id matches 0.. as @e[type=marker,tag=community_chest_card] unless score @s card_id matches 0.. run scoreboard players set @s card_order 16
execute unless score jail_card_community_chest player_id matches 0.. as @e[type=marker,tag=community_chest_card] unless score @s card_id matches 0.. run scoreboard players set @s card_id 1



# Card Drawing

execute as @e[type=interaction,tag=chest_hitbox,tag=active] on target if score @s player_id = current_turn player_id run function monopoly:board/draw_card
execute if entity @e[type=item,tag=card,tag=!registered,nbt={OnGround:1b}] run function monopoly:board/select_card

# Inventory Checks

function monopoly:inventory/check_inventory
execute if entity @a[tag=update_inventory] run function monopoly:inventory/update_inventory



# Random thing to help if tokens bundle

execute as @e[tag=token,team=mooshroom] at @s if entity @e[tag=token,team=!mooshroom,distance=..0.005] run tp @s ~0.01 ~ ~0.01
execute as @e[tag=token,team=cat] at @s if entity @e[tag=token,team=!cat,distance=..0.005] run tp @s ~-0.01 ~ ~0.01
execute as @e[tag=token,team=frog] at @s if entity @e[tag=token,team=!frog,distance=..0.005] run tp @s ~0.01 ~ ~-0.01
execute as @e[tag=token,team=goat] at @s if entity @e[tag=token,team=!goat,distance=..0.005] run tp @s ~-0.01 ~ ~-0.01
execute as @e[tag=token,team=axolotl] at @s if entity @e[tag=token,team=!axolotl,distance=..0.005] run tp @s ~0.005 ~ ~-0.01
execute as @e[tag=token,team=pig] at @s if entity @e[tag=token,team=!pig,distance=..0.005] run tp @s ~-0.01 ~ ~-0.005


# Action Management

execute if score turn_state game_state matches 3.. as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @a[gamemode=!creative] if score @s player_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] player_id run tag @s add current_turn_interactor
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @a[gamemode=!creative] if score @s player_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] player_id at @s unless entity @e[type=interaction,tag=active,tag=!controller_hitbox,distance=..2.6] run tag @s add current_turn_interactor

execute if score action_delay timer matches 1.. run scoreboard players remove action_delay timer 1
execute unless score action_delay timer matches 1.. as @e[type=interaction,tag=controller_hitbox] on target if entity @s[tag=current_turn_interactor] if data entity @s SelectedItem.tag.ActionID run function monopoly:inventory/select_action

tag @e[type=interaction,tag=controller_hitbox,tag=singular] remove singular
execute if entity @a[tag=current_turn_interactor] run tag @e[type=interaction,tag=controller_hitbox,limit=1] add singular
kill @e[type=interaction,tag=controller_hitbox,tag=!singular]
execute if entity @a[tag=current_turn_interactor] unless entity @e[type=interaction,tag=controller_hitbox] run summon minecraft:interaction 0 90 0 {width:2f,height:2f,Tags:["controller_hitbox"]}
execute as @a[tag=current_turn_interactor] at @s run tp @e[type=interaction,tag=controller_hitbox] ~ ~0.5 ~

tag @a[tag=current_turn_interactor] remove current_turn_interactor


# Random thing to help if tokens bundle

execute as @e[tag=token,team=mooshroom] at @s if entity @e[tag=token,team=!mooshroom,distance=..0.005] run tp @s ~0.01 ~ ~0.01
execute as @e[tag=token,team=cat] at @s if entity @e[tag=token,team=!cat,distance=..0.005] run tp @s ~-0.01 ~ ~0.01
execute as @e[tag=token,team=frog] at @s if entity @e[tag=token,team=!frog,distance=..0.005] run tp @s ~0.01 ~ ~-0.01
execute as @e[tag=token,team=goat] at @s if entity @e[tag=token,team=!goat,distance=..0.005] run tp @s ~-0.01 ~ ~-0.01
execute as @e[tag=token,team=axolotl] at @s if entity @e[tag=token,team=!axolotl,distance=..0.005] run tp @s ~0.005 ~ ~-0.01
execute as @e[tag=token,team=pig] at @s if entity @e[tag=token,team=!pig,distance=..0.005] run tp @s ~-0.01 ~ ~-0.005



# Property Management Check

execute unless score action_delay timer matches 1.. as @e[type=interaction,tag=p_manage_entity,tag=!none] on target if score @s player_id = current_controller player_id run function monopoly:board/modify_property_state


# Auction Detection

execute if score auction_id space_id matches 1.. run tag @e[tag=token,tag=in_auction] add auction_check
execute as @e[tag=auction_check] unless score auction_turn player_id = @s player_id run tag @s remove auction_check
execute if score auction_id space_id matches 1.. if entity @e[tag=token,tag=in_auction] unless entity @e[tag=auction_check] run function monopoly:auction/auction_pass_turn
tag @e[tag=auction_check] remove auction_check

execute unless score action_delay timer matches 1.. as @e[type=interaction,tag=p_auction_entity,tag=!too_expensive,tag=!trader_hitbox] on target if score @s player_id = auction_turn player_id run function monopoly:auction/auction_action
execute as @e[tag=token,tag=in_auction] at @s unless entity @e[tag=token,tag=in_auction,distance=0.01..] run function monopoly:auction/end_auction

execute unless score auction_id space_id matches 1.. run tag @e[type=marker,tag=space,tag=needs_auction] add auction_check
execute as @e[type=marker,tag=space,tag=auction_check] at @s as @e[type=marker,tag=space,tag=auction_check,distance=0.01..] if score @s space_id > @e[type=marker,tag=space,tag=auction_check,sort=nearest,limit=1] space_id run tag @s remove auction_check
tag @e[type=marker,tag=space,tag=auction_check,limit=1] remove needs_auction
execute as @e[type=marker,tag=space,tag=auction_check,tag=!needs_auction] run scoreboard players operation auction_id space_id = @s space_id

tag @e[tag=auction_check] remove auction_check

execute if score auction_id space_id matches 1.. unless entity @e[tag=token,tag=in_auction] run function monopoly:auction/setup_auction


# Trade Stuff


execute unless score turn_state game_state matches 1..2 run kill @e[type=interaction,tag=trade_start_hitbox]
execute if score turn_state game_state matches 1..2 as @e[tag=token,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=interaction,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[type=interaction,tag=trade_start_hitbox] at @s unless entity @e[tag=token,scores={player_id=1..},distance=..0.01] run kill @s
execute if score turn_state game_state matches 1..2 as @e[tag=token,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=interaction,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:interaction ~ ~ ~ {width:0.85f,height:0.75f,Tags:["trade_start_hitbox","active"]}

execute unless score turn_state game_state matches 1..2 run kill @e[type=text_display,tag=trade_start_hitbox]
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=mooshroom,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=mooshroom,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=cat,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=cat,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=frog,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=frog,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=goat,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=goat,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=axolotl,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=axolotl,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=pig,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s run tp @e[type=text_display,tag=pig,tag=trade_start_hitbox,sort=nearest,limit=1] ~ ~ ~
execute if score turn_state game_state matches 1..2 as @e[type=text_display,tag=trade_start_hitbox] at @s unless entity @e[tag=token,scores={player_id=1..},distance=..0.01] run kill @s
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=mooshroom,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["mooshroom","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"red"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=cat,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["cat","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"gold"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=frog,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["frog","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"green"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=goat,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["goat","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"aqua"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=axolotl,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["axolotl","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"blue"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}
execute if score turn_state game_state matches 1..2 as @e[tag=token,team=pig,scores={player_id=1..}] unless score @s player_id = current_controller player_id at @s unless entity @e[type=text_display,tag=trade_start_hitbox,distance=..0.01] run summon minecraft:text_display ~ ~ ~ {Tags:["pig","trade_start_hitbox","active"],text:'[{"text":"Right Click ","color":"yellow","bold":true},{"text":"to Trade","bold":true,"color":"light_purple"}]',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0.95f,0f]},background:0,line_width:70,billboard:"center",shadow:1b,background:0}


execute as @a[tag=near_trade_offer] unless score @s player_id = current_controller player_id run tag @s remove near_trade_offer
execute as @a[tag=near_trade_offer] at @s unless entity @e[tag=trade_start_hitbox,type=interaction,distance=..2.6] run tag @s remove near_trade_offer
execute as @a[scores={player_id=1..},tag=!near_trade_offer] if score @s player_id = current_controller player_id at @s if entity @e[tag=trade_start_hitbox,type=interaction,distance=..2.6] run playsound minecraft:entity.experience_orb.pickup master @s ~ ~1 ~ 0.2 1.7
execute as @a[scores={player_id=1..},tag=!near_trade_offer] if score @s player_id = current_controller player_id at @s if entity @e[tag=trade_start_hitbox,type=interaction,distance=..2.6] run tag @s add near_trade_offer

execute unless score action_delay timer matches 1.. as @e[type=interaction,tag=trade_start_hitbox] at @s on target if score @s player_id = current_controller player_id as @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] unless score @s player_id = current_controller player_id run scoreboard players operation trade_target player_id = @s player_id
execute if score trade_target player_id = current_controller player_id run scoreboard players reset trade_target player_id
execute unless score action_delay timer matches 1.. as @e[type=interaction,tag=trade_start_hitbox] at @s on target if score @s player_id = current_controller player_id if score turn_state game_state matches 1..2 if score trade_target player_id matches 1.. run function monopoly:trade/setup_trade

execute unless score action_delay timer matches 1.. if score turn_state game_state matches -3 as @e[type=interaction,tag=p_trade_entity] on target if score @s player_id = current_controller player_id run function monopoly:trade/trade_action


# Money stuff

execute as @e[tag=token,scores={player_id=1..}] unless score @s money matches 0.. run scoreboard players set @s money 1500

execute as @e[tag=token,scores={payment=1..}] if score @s payment > @s money run tag @s add manage_debt
execute unless entity @e[tag=token,scores={money_owed=1..}] if entity @e[tag=token,tag=manage_debt] run function monopoly:money/debt_manager
tag @e[tag=manage_debt] remove manage_debt

execute if entity @e[tag=token,scores={payment=1..}] run function monopoly:money/receive_payment
execute if entity @e[tag=token,scores={payment=..-1}] unless entity @e[tag=token,scores={payment=1..}] run function monopoly:money/receive_payment

execute as @e[tag=token] run scoreboard players operation @s money_after_payment = @s money
execute as @e[tag=token] run scoreboard players operation @s money_after_payment -= @s payment

tag @a[tag=hide_money_text] remove hide_money_text



# Jail stuff

execute if score turn_state game_state matches -5 run function monopoly:movement/exit_jail

scoreboard players set @e[tag=token,tag=jailed] space_id 11
scoreboard players reset @e[tag=token,tag=!jailed,scores={jail_roll_count=1..}] jail_roll_count
scoreboard players set @e[tag=token,tag=jailed,scores={movement=1..}] movement 0

execute positioned 14 100 15 if block ~ ~ ~ minecraft:iron_bars if entity @e[tag=token,distance=..0.7,scores={movement=1..}] run playsound minecraft:block.iron_door.close block @a 14 100 15 1 0.6
execute positioned 14 100 15 if block ~ ~ ~ minecraft:iron_bars if entity @e[tag=token,distance=..0.7,scores={movement=1..}] run playsound minecraft:block.iron_door.close block @a 14 100 15 1 0.75

execute positioned 14 100 15 if block ~ ~ ~ minecraft:iron_bars if entity @e[tag=token,distance=..0.7,scores={movement=1..}] run setblock ~ ~ ~ air
execute positioned 14 100 15 unless block ~ ~ ~ minecraft:iron_bars unless entity @e[tag=token,distance=..0.7,scores={movement=1..}] run setblock ~ ~ ~ iron_bars
execute positioned 15 100 15 run tp @e[tag=token,distance=0.85..,tag=jailed] ~ ~ ~

execute if entity @e[tag=token,tag=jailed,tag=!jail_sound] run playsound minecraft:item.shield.break block @a 15 100 15 1.5 0.5 0.1
execute if entity @e[tag=token,tag=jailed,tag=!jail_sound] run playsound minecraft:item.shield.break block @a 15 100 15 1.5 0.6 0.1
execute if entity @e[tag=token,tag=jailed,tag=!jail_sound] run playsound minecraft:block.beacon.deactivate block @a 15 100 15 1.5 1.2 1

tag @e[tag=token,tag=jailed,tag=!jail_sound] add jail_sound
tag @e[tag=!jailed,tag=jail_sound] remove jail_sound


# Monopoly Detection

function monopoly:board/check_for_monopoly


# Crouching Mechanics

scoreboard players reset @a[scores={crouching=1..},tag=!crouch_mechanic] crouching

execute as @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] at @s run summon minecraft:marker ~ ~ ~ {Tags:["crouch_marker"]}
execute as @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] at @s as @e[type=marker,tag=crouch_marker,sort=nearest,limit=1] unless score @s crouch_id matches 1.. run tp @s ~ ~ ~ ~ ~
execute as @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] at @s as @e[type=marker,tag=crouch_marker,sort=nearest,limit=1] unless score @s crouch_id matches 1.. at @s run scoreboard players operation @s crouch_id = @p[scores={crouching=1..},tag=!crouching,gamemode=adventure] crouch_id
execute as @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] run attribute @s minecraft:generic.movement_speed base set 0.062
effect give @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] minecraft:invisibility infinite 0 true
tp @a[scores={crouching=1..,crouch_id=1..},gamemode=adventure] 1.7 135 0.0 90 90
execute as @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] at @s run playsound minecraft:entity.ender_dragon.flap master @s ~ ~1 ~ 0.5 1.5
tag @a[scores={crouching=1..,crouch_id=1..},tag=!crouching,gamemode=adventure] add crouching
execute as @e[type=marker,tag=crouch_marker] at @s as @a[tag=crouching,gamemode=adventure,scores={crouch_id=1..}] unless score @s crouching matches 1.. if score @s crouch_id = @e[type=marker,tag=crouch_marker,sort=nearest,limit=1] crouch_id run tp @s ~ ~ ~ ~ ~
execute as @a[tag=crouching,gamemode=adventure,scores={crouch_id=1..}] unless score @s crouching matches 1.. at @s run playsound minecraft:entity.ender_dragon.flap master @s ~ ~1 ~ 0.5 2
execute as @a[tag=crouching,gamemode=adventure,scores={crouch_id=1..}] unless score @s crouching matches 1.. at @s as @e[type=marker,tag=crouch_marker] if score @s crouch_id = @p[tag=crouching,gamemode=adventure] crouch_id run kill @s
execute as @a[tag=crouching] unless score @s crouching matches 1.. run attribute @s minecraft:generic.movement_speed base set 0.1
execute as @a[tag=crouching,scores={crouch_id=1..}] unless score @s crouching matches 1.. run effect clear @s minecraft:invisibility
execute as @a[tag=crouching] unless score @s crouching matches 1.. run tag @s remove crouching
scoreboard players reset @a[scores={crouching=1..}] crouching


# Token Updates

execute as @e[type=cat,tag=token] run data merge entity @s {Sitting:0}
execute as @e[type=frog,tag=token] run data merge entity @s {HurtTime:9s}
execute as @e[tag=baby] run data merge entity @s {Age:-1000}


# Actionbar display


setblock 0 98 0 oak_hanging_sign

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=mooshroom,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=mooshroom,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=mooshroom,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=mooshroom,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=mooshroom,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=mooshroom,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=mooshroom,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=mooshroom,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join mooshroom @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=mooshroom,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=cat,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=cat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=cat,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=cat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=cat,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=cat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=cat,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=cat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join cat @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=cat,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=frog,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=frog,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=frog,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=frog,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=frog,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=frog,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=frog,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=frog,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join frog @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=frog,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=goat,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=goat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=goat,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=goat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=goat,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=goat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=goat,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=goat,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join goat @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=goat,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=axolotl,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=axolotl,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=axolotl,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=axolotl,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=axolotl,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=axolotl,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=axolotl,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=axolotl,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join axolotl @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=axolotl,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

summon minecraft:armor_stand 0.0 100 0.0 {Tags:["money_display_data","register"],Marker:1,Small:1,Invisible:1,CustomName:'{"text":"Error!"}'}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=pig,limit=1] if score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=pig,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=pig,limit=1] if score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","underlined":true,"extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=pig,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute unless score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=pig,limit=1] unless score @s player_id = current_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=pig,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute if score turn_state game_state matches -4 as @e[tag=token,scores={player_id=1..},team=pig,limit=1] unless score @s player_id = auction_turn player_id run data merge block 0 98 0 {front_text:{messages:['{"text":"","extra":[{"text":"D","bold":true,"strikethrough":true},{"score":{"name":"@e[tag=token,scores={player_id=1..},team=pig,limit=1]","objective":"money"}}]}','{"text":""}','{"text":""}','{"text":""}']}}
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run data modify entity @s CustomName set string block 0 98 0 front_text.messages[0]
team join pig @e[type=armor_stand,tag=money_display_data,tag=register]
execute as @e[type=armor_stand,tag=money_display_data,tag=register] run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},team=pig,limit=1] player_id
tag @e[type=armor_stand,tag=money_display_data,tag=register] remove register

setblock 0 98 0 air


execute unless entity @e[type=armor_stand,tag=money_display_data,scores={player_id=5}] run scoreboard players remove @e[type=armor_stand,tag=money_display_data,scores={player_id=6..}] player_id 1
execute unless entity @e[type=armor_stand,tag=money_display_data,scores={player_id=4}] run scoreboard players remove @e[type=armor_stand,tag=money_display_data,scores={player_id=5..}] player_id 1
execute unless entity @e[type=armor_stand,tag=money_display_data,scores={player_id=3}] run scoreboard players remove @e[type=armor_stand,tag=money_display_data,scores={player_id=4..}] player_id 1
execute unless entity @e[type=armor_stand,tag=money_display_data,scores={player_id=2}] run scoreboard players remove @e[type=armor_stand,tag=money_display_data,scores={player_id=3..}] player_id 1
execute unless entity @e[type=armor_stand,tag=money_display_data,scores={player_id=1}] run scoreboard players remove @e[type=armor_stand,tag=money_display_data,scores={player_id=2..}] player_id 1

execute if score no_funds timer matches 1.. run scoreboard players remove no_funds timer 1
execute if score no_funds timer matches ..0 run scoreboard players reset no_funds timer

execute if score no_houses timer matches 1.. run scoreboard players remove no_houses timer 1
execute if score no_houses timer matches ..0 run scoreboard players reset no_houses timer

execute if score no_hotels timer matches 1.. run scoreboard players remove no_hotels timer 1
execute if score no_hotels timer matches ..0 run scoreboard players reset no_hotels timer


execute if score player_count constants matches 6.. run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=2}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=3}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=4}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=5}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=6}]"},{"text":" |"}]}
execute if score player_count constants matches 5 run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=2}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=3}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=4}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=5}]"},{"text":" |"}]}
execute if score player_count constants matches 4 run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=2}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=3}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=4}]"},{"text":" |"}]}
execute if score player_count constants matches 3 run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=2}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=3}]"},{"text":" |"}]}
execute if score player_count constants matches 2 run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" | "},{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=2}]"},{"text":" |"}]}
execute if score player_count constants matches 1 run title @a[tag=!near_trade_offer] actionbar {"text":"| ","color":"dark_gray","extra":[{"selector":"@e[type=armor_stand,tag=money_display_data,scores={player_id=1}]"},{"text":" |"}]}
execute unless score player_count constants matches 1.. run title @a[tag=!near_trade_offer] actionbar {"text":""}
execute if score no_funds timer matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s actionbar {"text":"Insufficient Funds","color":"red"}
execute if score no_houses timer matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s actionbar {"text":"Insufficient Houses","color":"red"}
execute if score no_hotels timer matches 1.. as @a[scores={player_id=1..}] if score @s player_id = current_controller player_id run title @s actionbar {"text":"Insufficient Hotels","color":"red"}
execute as @a[scores={player_id=1..},tag=near_trade_offer] if score @s player_id = current_controller player_id run title @s actionbar {"text":"Right Click","color":"yellow","underlined":true,"bold":true,"extra":[{"text":" token to trade","underlined":false,"color":"gold"}]}

execute if score turn_state game_state matches 9 as @a[scores={player_id=1..}] if score current_controller player_id = @s player_id run title @s actionbar {"text":"Are you sure you wish to ","color":"red","extra":[{"text":"Declare Bankruptcy","color":"dark_red","bold":true,"underlined":true},{"text":"?"}]}

kill @e[type=armor_stand,tag=money_display_data]

scoreboard players remove @e[type=minecraft:interaction,tag=p_token_entity,scores={timer=1..}] timer 1
execute as @e[type=minecraft:interaction,nbt={interaction:{}},tag=p_token_entity] unless score @s timer matches 1.. run scoreboard players set @s timer 7
execute as @e[type=minecraft:interaction,nbt={interaction:{}}] run data remove entity @s interaction
execute as @e[type=minecraft:interaction,nbt={attack:{}}] run data remove entity @s attack



# Bossbar HUD


bossbar set minecraft:hud players @a
execute if score game_pending game_state matches 1.. unless score game_end timer matches 1.. unless score start_animation timer matches 1.. run bossbar set minecraft:hud color red
execute if score game_pending game_state matches 1.. unless score game_end timer matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 0 run bossbar set minecraft:hud name [{"text":"Waiting for ","color":"red"},{"text":"2","color":"white"},{"text":" More Players...","color":"red"}]
execute if score game_pending game_state matches 1.. unless score game_end timer matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 1 run bossbar set minecraft:hud name [{"text":"Waiting for ","color":"red"},{"text":"1","color":"white"},{"text":" More Player...","color":"red"}]
execute if score game_pending game_state matches 1.. unless score game_end timer matches 1.. unless score start_animation timer matches 1.. if score player_teams_occupied constants matches 2.. run bossbar set minecraft:hud name {"text":"Ready to Play!","color":"white"}
execute if score game_pending game_state matches 1.. unless score game_end timer matches 1.. if score start_animation timer matches 1.. run bossbar set minecraft:hud name {"text":"Determining Turn Order...","color":"white"}


execute as @e[tag=token,scores={player_id=1..},team=mooshroom] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color red
execute as @e[tag=token,scores={player_id=1..},team=cat] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color yellow
execute as @e[tag=token,scores={player_id=1..},team=frog] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color green
execute as @e[tag=token,scores={player_id=1..},team=goat] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color blue
execute as @e[tag=token,scores={player_id=1..},team=axolotl] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color purple
execute as @e[tag=token,scores={player_id=1..},team=pig] if score @s player_id = current_controller player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud color pink


execute as @e[tag=token,scores={player_id=1..},team=mooshroom] unless entity @a[scores={player_id=1..},team=mooshroom_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Mooshroom's","color":"red"},{"text":" Turn","color":"yellow"}]
execute as @e[tag=token,scores={player_id=1..},team=cat] unless entity @a[scores={player_id=1..},team=cat_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Cat's","color":"gold"},{"text":" Turn","color":"yellow"}]
execute as @e[tag=token,scores={player_id=1..},team=frog] unless entity @a[scores={player_id=1..},team=frog_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Frog's","color":"green"},{"text":" Turn","color":"yellow"}]
execute as @e[tag=token,scores={player_id=1..},team=goat] unless entity @a[scores={player_id=1..},team=goat_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Goat's","color":"aqua"},{"text":" Turn","color":"yellow"}]
execute as @e[tag=token,scores={player_id=1..},team=axolotl] unless entity @a[scores={player_id=1..},team=axolotl_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Axolotl's","color":"blue"},{"text":" Turn","color":"yellow"}]
execute as @e[tag=token,scores={player_id=1..},team=pig] unless entity @a[scores={player_id=1..},team=pig_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"text":"Pig's","color":"light_purple"},{"text":" Turn","color":"yellow"}]


execute as @a[scores={player_id=1..},team=mooshroom_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"red"},{"text":" Turn","color":"yellow"}]
execute as @a[scores={player_id=1..},team=cat_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"gold"},{"text":" Turn","color":"yellow"}]
execute as @a[scores={player_id=1..},team=frog_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"green"},{"text":" Turn","color":"yellow"}]
execute as @a[scores={player_id=1..},team=goat_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"aqua"},{"text":" Turn","color":"yellow"}]
execute as @a[scores={player_id=1..},team=axolotl_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"blue"},{"text":" Turn","color":"yellow"}]
execute as @a[scores={player_id=1..},team=pig_player] if score @s player_id = current_turn player_id unless score game_pending game_state matches 1.. run bossbar set minecraft:hud name [{"selector":"@s"},{"text":"'s","color":"light_purple"},{"text":" Turn","color":"yellow"}]



# End Game Stuff

execute if score game_end timer matches 1.. run scoreboard players remove game_end timer 1
execute if score game_end timer matches 200 run function monopoly:board/spawn_firework
execute if score game_end timer matches 160 run function monopoly:board/spawn_firework
execute if score game_end timer matches 120 run function monopoly:board/spawn_firework
execute if score game_end timer matches 80 run function monopoly:board/spawn_firework
execute if score game_end timer matches 40 run function monopoly:board/spawn_firework
execute if score game_end timer matches ..0 run function monopoly:system/reset_game 




execute if score game_end timer matches ..0 run function monopoly:board/spawn_firework

execute if score game_end timer matches ..0 run tellraw @a {"text":"\n<","color":"dark_aqua","extra":[{"text":"!","color":"aqua"},{"text":"> "},{"text":"Enjoying ","color":"gray"},{"text":"MINEOPOLY","bold":true,"color":"white"},{"text":"? Consider ","color":"gray"},{"text":"Donating","color":"light_purple"},{"text":" to help support future projects by ","color":"gray"},{"text":"CanadianHybrid","color":"red"},{"text":"!","color":"gray"}]}
execute if score game_end timer matches ..0 run tellraw @a {"text":"\n[","bold":true,"color":"dark_aqua","bold":true,"extra":[{"text":"> ","color":"aqua"},{"text":"Click Here to Donate","underlined":true,"color":"green","clickEvent":{"action":"open_url","value":"https://www.paypal.com/donate/?hosted_button_id=KJQDR266ZBHZW"},"hoverEvent":{"action":"show_text","contents":[{"text":"Donate via ","color":"yellow","extra":[{"text":"PayPal","color":"green"}]}]}},{"text":" <","color":"aqua"},{"text":"]\n"}]}
execute if score game_end timer matches ..0 as @a at @s run playsound minecraft:block.note_block.harp master @s ~ ~1 ~ 0.4 2
execute if score game_end timer matches ..0 as @a at @s run playsound minecraft:block.note_block.harp master @s ~ ~1 ~ 0.4 1.5







execute if score game_end timer matches ..0 run scoreboard players reset game_end timer

