scoreboard players operation turn_state game_state = auction_turn_state game_state
scoreboard players operation auction_turn player_id = @e[tag=token,tag=in_auction,limit=1] player_id
tag @e[tag=current_auction_turn] remove current_auction_turn
scoreboard players operation @e[tag=token,tag=in_auction,limit=1] payment += highest_bid money

execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id run scoreboard players operation @s player_id = @e[tag=token,tag=in_auction,limit=1] player_id
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id unless score @s property_state matches -1.. run scoreboard players set @s property_state 0

execute if score auction_id space_id matches 41 run scoreboard players add @e[tag=token,tag=in_auction,limit=1] extra_houses 1
execute if score auction_id space_id matches 42 run scoreboard players add @e[tag=token,tag=in_auction,limit=1] extra_hotels 1

function monopoly:system/update_message_targets
tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" won the auction at ","color":"gray","italic":true},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true,"italic":true},{"score":{"name":"highest_bid","objective":"money"},"italic":true,"color":"aqua"},{"text":".","color":"gray","italic":true}]
execute as @e[type=marker,tag=space,scores={space_id=1..}] if score @s space_id = auction_id space_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" obtained ","color":"gray","italic":true},{"selector":"@s","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score auction_id space_id matches 41 run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" obtained the ","color":"gray","italic":true},{"text":"Last House","color":"dark_green","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score auction_id space_id matches 42 run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_auction]","italic":true},{"text":" obtained the ","color":"gray","italic":true},{"text":"Last Hotel","color":"dark_red","italic":true},{"text":".","color":"gray","italic":true}] 


execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run particle poof ^ ^0.5 ^2.5 0.2 0.2 0.2 0.1 20
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:ui.stonecutter.take_result block @a ^ ^0.5 ^2.5 0.5 0.5 0.1
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:block.piston.extend block @a ^ ^0.5 ^2.5 1 2 0.1
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:block.wooden_door.open block @a ^ ^0.5 ^2.5 1 0.5 0.1
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:block.anvil.use block @a ^ ^0.5 ^2.5 0.5 1.6 0.1
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:entity.player.levelup block @a ^ ^0.5 ^2.5 0.5 0.8 0.1
execute if score auction_id space_id matches 1..39 as @e[type=marker,tag=space] if score @s space_id = auction_id space_id at @s run playsound minecraft:entity.zombie_villager.cure block @a ^ ^0.5 ^2.5 0.4 2 0.1

scoreboard players reset auction_id space_id
scoreboard players reset auction_turn player_id

tag @a add update_inventory
tag @a add disable_inventory_checks

tag @a add hide_money_text

title @a times 0 30 20
title @a title ""
title @a subtitle {"text":"Auction Won!","bold":true,"color":"green"}
execute as @a at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.6 2
execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~1 ~ 1 0.75
execute as @a at @s run playsound minecraft:block.beacon.power_select master @s ~ ~1 ~ 2 1.5

function monopoly:board/update_property_visuals
execute if score turn_state game_state matches -2 run function monopoly:board/property_management_entities
execute as @e[tag=p_auction_entity,tag=alive] at @s run tp @s ~ ~-50 ~
kill @e[tag=p_auction_entity]

tag @e[tag=in_auction] remove in_auction
tag @a add update_inventory
tag @a add disable_inventory_checks