
scoreboard players set house_count constants 32
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=1..4}] run scoreboard players operation house_count constants -= @s property_state
execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] run scoreboard players operation house_count constants -= @s extra_houses
scoreboard players set hotel_count constants 12
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=5..}] run scoreboard players remove hotel_count constants 1
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] run scoreboard players operation hotel_count constants -= @s extra_hotels

scoreboard players set house_count_temp constants 32
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=1..4}] run scoreboard players operation house_count_temp constants -= @s property_state
execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] unless score @s player_id = current_controller player_id run scoreboard players operation house_count_temp constants -= @s extra_houses
scoreboard players set hotel_count_temp constants 12
execute as @e[type=marker,tag=space,tag=monopoly,scores={property_state=5..}] run scoreboard players remove hotel_count_temp constants 1
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] unless score @s player_id = current_controller player_id run scoreboard players operation hotel_count_temp constants -= @s extra_hotels

execute as @e[tag=token,scores={player_id=1..,extra_houses=1..}] if score @s player_id = current_controller player_id run scoreboard players operation houses_pending constants = @s extra_houses
execute as @e[tag=token,scores={player_id=1..,extra_hotels=1..}] if score @s player_id = current_controller player_id run scoreboard players operation hotels_pending constants = @s extra_hotels

execute as @e[tag=token] run scoreboard players operation @s money_after_payment = @s money
execute as @e[tag=token] run scoreboard players operation @s money_after_payment -= @s payment

kill @e[tag=p_manage_entity]

execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly] if score @s player_id = current_controller player_id at @s as @e[type=marker,distance=0.01..,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly] if score @s player_id = current_controller player_id if score @s space_type = @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly,sort=nearest,limit=1] space_type if score @s property_state > @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly,sort=nearest,limit=1] property_state run tag @s add cant_upgrade
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly] if score @s player_id = current_controller player_id at @s as @e[type=marker,distance=0.01..,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly] if score @s player_id = current_controller player_id if score @s space_type = @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly,sort=nearest,limit=1] space_type if score @s property_state < @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8},tag=monopoly,sort=nearest,limit=1] property_state run tag @s add cant_downgrade

execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..10,property_state=0..},tag=!monopoly] if score @s player_id = current_controller player_id at @s run summon interaction ^ ^1 ^1.5 {Tags:["p_manage_entity","active","down","mortgage"],width:0.6f,height:0.6f}
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..10,property_state=-1},tag=!monopoly] if score @s player_id = current_controller player_id at @s run summon interaction ^ ^1 ^1.5 {Tags:["p_manage_entity","active","up","mortgage"],width:0.6f,height:0.6f}

execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0},tag=monopoly,tag=!cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","down","mortgage"],width:0.6f,height:0.6f}
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=-1},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","up","mortgage"],width:0.6f,height:0.6f}
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=-1},tag=monopoly] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","none","mortgage"],width:0.6f,height:0.6f}
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=5},tag=monopoly] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","none","mortgage"],width:0.6f,height:0.6f}

execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=1..4},tag=monopoly,tag=!cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","down","house"],width:0.6f,height:0.6f}
execute if score house_count constants matches 4.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=5},tag=monopoly,tag=!cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","down","house","hotel"],width:0.6f,height:0.6f}
execute if score house_count constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0..3},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","up","house"],width:0.6f,height:0.6f}
execute if score hotel_count constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=4},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","up","house","hotel"],width:0.6f,height:0.6f}
execute unless score house_count constants matches 4.. if score house_count_temp constants matches 4.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=5},tag=monopoly,tag=!cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","down","house","hotel"],width:0.6f,height:0.6f}
execute unless score house_count constants matches 1.. if score house_count_temp constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0..3},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","up","house"],width:0.6f,height:0.6f}
execute unless score hotel_count constants matches 1.. if score hotel_count_temp constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=4},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","up","house","hotel"],width:0.6f,height:0.6f}

execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0..4},tag=monopoly,tag=cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","none","house"],width:0.6f,height:0.6f}
execute as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0..4},tag=monopoly,tag=cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","none","house"],width:0.6f,height:0.6f}

execute unless score house_count constants matches 4.. unless score house_count_temp constants matches 4.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=5},tag=monopoly,tag=!cant_downgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","no_building","down","house","hotel"],width:0.6f,height:0.6f}
execute unless score house_count constants matches 1.. unless score house_count_temp constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=0..3},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","no_building","up","house"],width:0.6f,height:0.6f}
execute unless score hotel_count constants matches 1.. unless score hotel_count_temp constants matches 1.. as @e[type=marker,tag=space,scores={player_id=1..,space_type=1..8,property_state=4},tag=monopoly,tag=!cant_upgrade] if score @s player_id = current_controller player_id at @s run summon interaction ^-0.5 ^1 ^1.5 {Tags:["p_manage_entity","active","no_building","up","house","hotel"],width:0.6f,height:0.6f}


scoreboard players set @e[type=interaction,tag=p_manage_entity] money 0

execute as @e[type=interaction,tag=down,tag=mortgage,tag=p_manage_entity] at @s run scoreboard players operation @s money = @e[type=marker,tag=space,sort=nearest,limit=1] mortgage_value
execute as @e[type=interaction,tag=up,tag=mortgage,tag=p_manage_entity] at @s run scoreboard players operation @s money = @e[type=marker,tag=space,sort=nearest,limit=1] unmortgage_cost
execute as @e[type=interaction,tag=down,tag=house,tag=p_manage_entity] at @s run scoreboard players operation @s money = @e[type=marker,tag=space,sort=nearest,limit=1] house_return
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id unless score @s extra_houses matches 1.. as @e[type=interaction,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run scoreboard players operation @s money = @e[type=marker,tag=space,sort=nearest,limit=1] house_cost
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id if score @s extra_houses matches 1.. as @e[type=interaction,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run scoreboard players set @s money 0
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id unless score @s extra_hotels matches 1.. as @e[type=interaction,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run scoreboard players operation @s money = @e[type=marker,tag=space,sort=nearest,limit=1] house_cost
execute as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id if score @s extra_hotels matches 1.. as @e[type=interaction,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run scoreboard players set @s money 0

execute as @e[type=interaction,tag=up,tag=!no_building,tag=p_manage_entity] at @s as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id if score @s money_after_payment < @e[type=interaction,tag=up,tag=p_manage_entity,tag=!no_building,sort=nearest,limit=1] money run tag @e[type=interaction,tag=up,tag=p_manage_entity,tag=!no_building,sort=nearest,limit=1] add too_expensive

execute unless score house_count constants matches 1 as @e[type=interaction,tag=house,tag=!hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}],Glowing:1b}
execute if score house_count constants matches 1 unless score house_count_temp constants matches 1 as @e[type=interaction,tag=house,tag=!hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}],Glowing:1b}
execute if score house_count constants matches 1 if score house_count_temp constants matches 1 as @e[type=interaction,tag=house,tag=!hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:yellow_concrete",Count:1b}],Glowing:1b}
execute unless score hotel_count constants matches 1 as @e[type=interaction,tag=house,tag=hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}],Glowing:1b}
execute if score hotel_count constants matches 1 unless score hotel_count_temp constants matches 1 as @e[type=interaction,tag=house,tag=hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}],Glowing:1b}
execute if score hotel_count constants matches 1 if score hotel_count_temp constants matches 1 as @e[type=interaction,tag=house,tag=hotel,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:yellow_concrete",Count:1b}],Glowing:1b}
execute as @e[type=interaction,tag=too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","error","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:light_gray_concrete",Count:1b}],Glowing:1b}
execute as @e[type=interaction,tag=!no_building,tag=house,tag=!hotel,tag=down,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}],Glowing:1b}
execute unless score house_count constants matches 1..4 as @e[type=interaction,tag=!no_building,tag=house,tag=hotel,tag=down,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}],Glowing:1b}
execute if score house_count constants matches 1..4 unless score house_count_temp constants matches 4 as @e[type=interaction,tag=!no_building,tag=house,tag=hotel,tag=down,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}],Glowing:1b}
execute if score house_count constants matches 1..4 if score house_count_temp constants matches 4 as @e[type=interaction,tag=!no_building,tag=house,tag=hotel,tag=down,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:yellow_concrete",Count:1b}],Glowing:1b}
execute as @e[type=interaction,tag=none,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:black_concrete",Count:1b}]}
execute as @e[type=interaction,tag=no_building,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","error","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:light_gray_concrete",Count:1b}],Glowing:1b}
execute as @e[type=interaction,tag=mortgage,tag=!no_building,tag=!too_expensive,tag=up,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","up"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:lime_concrete",Count:1b}],Glowing:1b}
execute as @e[type=interaction,tag=mortgage,tag=!no_building,tag=!too_expensive,tag=down,tag=p_manage_entity] at @s run summon armor_stand ~ ~-0.58 ~ {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Small:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}],Glowing:1b}



summon interaction 0.0 101.3 0.0 {Tags:["p_manage_entity","active","quit_management"],width:0.8f,height:0.8f}
summon armor_stand 0.0 100 0.0 {Tags:["p_manage_entity","hitbox_display_icon","down"],Marker:1,Invisible:1,ArmorItems:[{},{},{},{id:"minecraft:red_concrete",Count:1b}],Glowing:1b}
summon text_display 0.0 102.15 0.0 {Tags:["p_manage_entity"],text:'{"text":"Exit Property Management","bold":true,"color":"red"}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:80,billboard:"center",shadow:1b,background:0}
summon text_display 1.5 102.15 1.5 {Tags:["p_manage_entity"],text:'{"text":"Houses Available ","bold":true,"color":"dark_green","extra":[{"score":{"name":"house_count","objective":"constants"},"color":"green"}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:60,billboard:"center",shadow:1b,background:0}
summon text_display -1.5 102.15 -1.5 {Tags:["p_manage_entity"],text:'{"text":"Hotels Available ","bold":true,"color":"dark_red","extra":[{"score":{"name":"hotel_count","objective":"constants"},"color":"red"}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:60,billboard:"center",shadow:1b,background:0}
execute if score houses_pending constants matches 1.. run summon text_display 1.0 103.15 1.0 {Tags:["p_manage_entity"],text:'{"text":"Pending Houses ","bold":true,"color":"dark_aqua","extra":[{"score":{"name":"houses_pending","objective":"constants"},"color":"aqua"}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:46,billboard:"center",shadow:1b,background:0}
execute if score hotels_pending constants matches 1.. run summon text_display -1.0 103.15 -1.0 {Tags:["p_manage_entity"],text:'{"text":"Pending Hotels ","bold":true,"color":"dark_purple","extra":[{"score":{"name":"hotels_pending","objective":"constants"},"color":"light_purple"}]}',transformation:{right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:46,billboard:"center",shadow:1b,background:0}

team join positive_entity @e[type=armor_stand,tag=p_manage_entity,tag=up,tag=!error,tag=hitbox_display_icon]
team join neutral_entity @e[type=armor_stand,tag=p_manage_entity,tag=up,tag=error,tag=hitbox_display_icon]
team join negative_entity @e[type=armor_stand,tag=p_manage_entity,tag=down,tag=hitbox_display_icon]

execute as @e[type=interaction,tag=up,tag=mortgage,tag=p_manage_entity] at @s run summon text_display ~ ~0.58 ~ {Tags:["p_manage_entity"],transformation:{right_rotation:[0f,0f,0f,1f],scale:[0.7f,0.7f,0.7f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:60,billboard:"center",shadow:1b,background:0}
execute as @e[type=interaction,tag=down,tag=mortgage,tag=p_manage_entity] at @s run summon text_display ~ ~0.58 ~ {Tags:["p_manage_entity"],transformation:{right_rotation:[0f,0f,0f,1f],scale:[0.7f,0.7f,0.7f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:48,billboard:"center",shadow:1b,background:0}
execute as @e[type=interaction,tag=up,tag=house,tag=p_manage_entity] at @s run summon text_display ~ ~0.58 ~ {Tags:["p_manage_entity"],transformation:{right_rotation:[0f,0f,0f,1f],scale:[0.7f,0.7f,0.7f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:48,billboard:"center",shadow:1b,background:0}
execute as @e[type=interaction,tag=down,tag=house,tag=p_manage_entity] at @s run summon text_display ~ ~0.58 ~ {Tags:["p_manage_entity"],transformation:{right_rotation:[0f,0f,0f,1f],scale:[0.7f,0.7f,0.7f],left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f]},background:0,line_width:48,billboard:"center",shadow:1b,background:0}

execute as @e[type=interaction,tag=!too_expensive,tag=up,tag=mortgage,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Unmortgage ","color":"green"},{"text":"-","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:60}
execute as @e[type=interaction,tag=too_expensive,tag=up,tag=mortgage,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Unmortgage ","color":"gray"},{"text":"-","color":"red"},{"text":"D","color":"dark_red","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_red"},{"text":" "}]',line_width:60}
execute as @e[type=interaction,tag=down,tag=mortgage,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Mortgage ","color":"red"},{"text":"+","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:48}
execute as @e[type=interaction,tag=no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy House ","color":"gray"},{"text":"-","color":"gray"},{"text":"D","color":"dark_gray","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_gray"},{"text":" "}]',line_width:35}
execute as @e[type=interaction,tag=no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy Hotel ","color":"gray"},{"text":"-","color":"gray"},{"text":"D","color":"dark_gray","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_gray"},{"text":" "}]',line_width:35}
execute as @e[type=interaction,tag=too_expensive,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy House ","color":"gray"},{"text":"-","color":"red"},{"text":"D","color":"dark_red","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_red"},{"text":" "}]',line_width:35}
execute as @e[type=interaction,tag=too_expensive,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy Hotel ","color":"gray"},{"text":"-","color":"red"},{"text":"D","color":"dark_red","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_red"},{"text":" "}]',line_width:35}
execute as @e[type=interaction,tag=down,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Sell House ","color":"red"},{"text":"+","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute as @e[type=interaction,tag=down,tag=no_building,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Sell Hotel ","color":"gray"},{"text":"+","color":"gray"},{"text":"D","color":"dark_gray","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_gray"},{"text":" "}]',line_width:35}





execute unless score house_count constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy House ","color":"green"},{"text":"-","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score house_count constants matches 1 unless score house_count_temp constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy House ","color":"green"},{"text":"-","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score house_count constants matches 1 if score house_count_temp constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=!hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy House ","color":"green"},{"text":"Auction","color":"gold","bold":true}]',line_width:45}
execute unless score hotel_count constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy Hotel ","color":"green"},{"text":"-","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score hotel_count constants matches 1 unless score hotel_count_temp constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy Hotel ","color":"green"},{"text":"-","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score hotel_count constants matches 1 if score hotel_count_temp constants matches 1 as @e[type=interaction,tag=!no_building,tag=!too_expensive,tag=up,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Buy Hotel ","color":"green"},{"text":"Auction","color":"gold","bold":true}]',line_width:45}
execute unless score house_count constants matches 1..4 as @e[type=interaction,tag=down,tag=!no_building,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Sell Hotel ","color":"red"},{"text":"+","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score house_count constants matches 1..4 unless score house_count_temp constants matches 4 as @e[type=interaction,tag=down,tag=!no_building,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Sell Hotel ","color":"red"},{"text":"+","color":"aqua"},{"text":"D","color":"dark_aqua","bold":true,"strikethrough":true},{"score":{"name":"@e[type=interaction,tag=p_manage_entity,sort=nearest,limit=1]","objective":"money"},"color":"dark_aqua"},{"text":" "}]',line_width:35}
execute if score house_count constants matches 1..4 if score house_count_temp constants matches 4 as @e[type=interaction,tag=down,tag=!no_building,tag=house,tag=hotel,tag=p_manage_entity] at @s run data merge entity @e[type=text_display,tag=p_manage_entity,sort=nearest,limit=1] {text:'[{"text":"Sell Hotel ","color":"red"},{"text":"Auction","color":"gold","bold":true}]',line_width:45}



tag @e[type=marker,tag=space,tag=cant_upgrade] remove cant_upgrade
tag @e[type=marker,tag=space,tag=cant_downgrade] remove cant_downgrade

scoreboard players reset house_count_temp constants
scoreboard players reset hotel_count_temp constants

scoreboard players reset houses_pending constants
scoreboard players reset hotels_pending constants