
tag @a[gamemode=creative,tag=!disable_inventory_checks] add disable_inventory_checks
tag @a[gamemode=!creative,tag=disable_inventory_checks] add update_inventory

execute as @e[tag=token] if score @s player_id = current_controller player_id at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,sort=nearest,limit=1] player_id run tag @s add controller_inv_check

tag @a[tag=!controller_inv_check,tag=!disable_inventory_checks,nbt={Inventory:[{Slot:0b}]}] add update_inventory
tag @a[tag=!controller_inv_check,tag=!disable_inventory_checks,nbt={Inventory:[{Slot:1b}]}] add update_inventory
tag @a[tag=!controller_inv_check,tag=!disable_inventory_checks,nbt={Inventory:[{Slot:2b}]}] add update_inventory

execute unless score turn_state game_state matches 1.. run tag @a[nbt={Inventory:[{Slot:0b}]},tag=!disable_inventory_checks] add update_inventory
execute unless score turn_state game_state matches 1.. run tag @a[nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute unless score turn_state game_state matches 1.. run tag @a[nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 1 as @e[tag=token,tag=!extra_turn] if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:0b,id:"minecraft:barrier",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 as @e[tag=token,tag=extra_turn] if score @s player_id = current_controller player_id if score double_count roll matches ..1 run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:0b,id:"minecraft:gold_ingot",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 as @e[tag=token,tag=extra_turn] if score @s player_id = current_controller player_id if score double_count roll matches 2.. run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:0b,id:"minecraft:copper_ingot",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:1b,id:"minecraft:book",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 run tag @a[tag=controller_inv_check,tag=near_trade_offer,nbt={Inventory:[{Slot:0b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 run tag @a[tag=controller_inv_check,tag=near_trade_offer,nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 1 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory


execute if score turn_state game_state matches 2 as @e[tag=token,tag=!near_trade_offer] if score @s money >= @s money_owed if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:diamond",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 as @e[tag=token,tag=!near_trade_offer] unless score @s money >= @s money_owed if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:coal",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:1b,id:"minecraft:book",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 run tag @a[tag=controller_inv_check,tag=!near_trade_offer,nbt=!{Inventory:[{Slot:2b,id:"minecraft:gunpowder",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 run tag @a[tag=controller_inv_check,tag=near_trade_offer,nbt={Inventory:[{Slot:0b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 run tag @a[tag=controller_inv_check,tag=near_trade_offer,nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 2 run tag @a[tag=controller_inv_check,tag=near_trade_offer,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 3 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:iron_ingot",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 3 as @e[tag=token,tag=jailed] unless score @s money matches 50.. if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:coal",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 3 as @e[tag=token,tag=jailed,scores={money=50..}] if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:diamond",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 3 as @e[tag=token,tag=jailed] if score @s player_id = current_controller player_id if score @s player_id = jail_card_chance player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:2b,id:"minecraft:paper",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 3 as @e[tag=token,tag=jailed] if score @s player_id = current_controller player_id if score @s player_id = jail_card_community_chest player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:2b,id:"minecraft:paper",Count:1b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 4 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:ender_eye",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 4 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 4 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 5 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:diamond",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 5 as @e[tag=token] if score @s player_id = current_controller player_id if score @s player_id = jail_card_chance player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:paper",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 5 as @e[tag=token] if score @s player_id = current_controller player_id if score @s player_id = jail_card_community_chest player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:paper",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 5 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 6 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:paper",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 6 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 6 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 7 as @e[tag=token] if score @s money >= @s buy_cost if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:diamond",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 7 as @e[tag=token] unless score @s money >= @s buy_cost if score @s player_id = current_controller player_id run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:coal",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 7 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:emerald",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 7 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 8 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:emerald",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 8 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:structure_void",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 8 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:2b,id:"minecraft:barrier",Count:1b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 9 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:barrier",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 9 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:1b,id:"minecraft:gunpowder",Count:1b}]},tag=!disable_inventory_checks] add update_inventory

execute if score turn_state game_state matches 10 run tag @a[tag=controller_inv_check,nbt=!{Inventory:[{Slot:0b,id:"minecraft:diamond",Count:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 10 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:1b}]},tag=!disable_inventory_checks] add update_inventory
execute if score turn_state game_state matches 10 run tag @a[tag=controller_inv_check,nbt={Inventory:[{Slot:2b}]},tag=!disable_inventory_checks] add update_inventory

execute if entity @e[tag=token,scores={player_id=6}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:8b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=6}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:8b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=6}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:8b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=6}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:8b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if entity @e[tag=token,scores={player_id=5}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:7b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=5}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:7b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=5}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:7b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=5}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:7b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if entity @e[tag=token,scores={player_id=4}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:6b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=4}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:6b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=4}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:6b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=4}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:6b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if entity @e[tag=token,scores={player_id=3}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:5b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=3}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:5b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=3}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:5b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=3}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:5b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if entity @e[tag=token,scores={player_id=2}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:4b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=2}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:4b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=2}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:4b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=2}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:4b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if entity @e[tag=token,scores={player_id=1}] run tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:3b,id:"minecraft:player_head",Count:1b}]}] add update_inventory
execute as @e[tag=token,scores={player_id=1}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:3b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-2.5 ~ ~45
execute as @e[tag=token,scores={player_id=1}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:3b,id:"minecraft:player_head",Count:1b}]}] ^ ^ ^-1 ~ ~45
execute if entity @e[tag=token,scores={player_id=1}] as @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:3b,id:"minecraft:player_head",Count:1b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

tag @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:9b,id:"minecraft:brown_concrete",Count:1b},{Slot:18b,id:"minecraft:brown_concrete",Count:1b},{Slot:10b,id:"minecraft:light_blue_concrete",Count:1b},{Slot:19b,id:"minecraft:light_blue_concrete",Count:1b},{Slot:28b,id:"minecraft:light_blue_concrete",Count:1b},{Slot:11b,id:"minecraft:magenta_concrete",Count:1b},{Slot:20b,id:"minecraft:magenta_concrete",Count:1b},{Slot:29b,id:"minecraft:magenta_concrete",Count:1b},{Slot:12b,id:"minecraft:orange_concrete",Count:1b},{Slot:21b,id:"minecraft:orange_concrete",Count:1b},{Slot:30b,id:"minecraft:orange_concrete",Count:1b},{Slot:13b,id:"minecraft:red_concrete",Count:1b},{Slot:22b,id:"minecraft:red_concrete",Count:1b},{Slot:31b,id:"minecraft:red_concrete",Count:1b},{Slot:14b,id:"minecraft:yellow_concrete",Count:1b},{Slot:23b,id:"minecraft:yellow_concrete",Count:1b},{Slot:32b,id:"minecraft:yellow_concrete",Count:1b},{Slot:15b,id:"minecraft:lime_concrete",Count:1b},{Slot:24b,id:"minecraft:lime_concrete",Count:1b},{Slot:33b,id:"minecraft:lime_concrete",Count:1b},{Slot:16b,id:"minecraft:blue_concrete",Count:1b},{Slot:25b,id:"minecraft:blue_concrete",Count:1b},{Slot:35b,id:"minecraft:saddle"}]}] add update_inventory
tag @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:19b,id:"minecraft:oak_boat"},{Slot:20b,id:"minecraft:saddle"},{Slot:21b,id:"minecraft:minecart"},{Slot:22b,id:"minecraft:elytra"},{Slot:23b,id:"minecraft:water_bucket"},{Slot:24b,id:"minecraft:lava_bucket"},{Slot:30b,id:"minecraft:paper",Count:1b},{Slot:31b,id:"minecraft:paper",Count:1b},{Slot:35b,id:"minecraft:blue_concrete",Count:1b}]}] add update_inventory


execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:18b}]}] run tp @s 18 100 -12.0 90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:9b}]}] run tp @s 18 100 -6.0 90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:28b}]}] run tp @s 18 100 3.0 90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:19b}]}] run tp @s 18 100 9.0 90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:10b}]}] run tp @s 18 100 12.0 90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:29b}]}] run tp @s 12.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:20b}]}] run tp @s 6.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:11b}]}] run tp @s 3.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:30b}]}] run tp @s -3.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:21b}]}] run tp @s -9.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:12b}]}] run tp @s -12.0 100 18 180 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:31b}]}] run tp @s -19 100 12.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:22b}]}] run tp @s -19 100 6.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:13b}]}] run tp @s -19 100 3.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:32b}]}] run tp @s -19 100 -3.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:23b}]}] run tp @s -19 100 -6.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:14b}]}] run tp @s -19 100 -12.0 -90 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:33b}]}] run tp @s -12.0 100 -19 0 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:24b}]}] run tp @s -9.0 100 -19 0 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:15b}]}] run tp @s -3.0 100 -19 0 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:25b}]}] run tp @s 6.0 100 -19 0 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:16b}]}] run tp @s 12.0 100 -19 0 50
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:9b},{Slot:18b},{Slot:10b},{Slot:19b},{Slot:28b},{Slot:11b},{Slot:20b},{Slot:29b},{Slot:12b},{Slot:21b},{Slot:30b},{Slot:13b},{Slot:22b},{Slot:31b},{Slot:14b},{Slot:23b},{Slot:32b},{Slot:15b},{Slot:24b},{Slot:33b},{Slot:16b},{Slot:25b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5


execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:19b}]}] run tp @s 18 100 0.0 90 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:20b}]}] run tp @s 0.0 100 18 180 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:21b}]}] run tp @s -19 100 0.0 -90 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:22b}]}] run tp @s 0.0 100 -19 0 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:23b}]}] run tp @s 9.0 100 18 180 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:24b}]}] run tp @s -19 100 -9.0 -90 50
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:30b}]}] run tp @s 18 100 18 135 30
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:31b}]}] run tp @s 18 100 18 135 30
execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:19b},{Slot:20b},{Slot:21b},{Slot:22b},{Slot:23b},{Slot:24b},{Slot:30b},{Slot:31b}]}] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute as @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:35b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.8
execute as @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:35b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 2
execute as @a[tag=view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.8
execute as @a[tag=view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 2 1.5
execute as @a[tag=!view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 2
execute as @a[tag=!view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~1 ~ 0.3 1.5
execute as @a[tag=crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.8
execute as @a[tag=crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 2 1.5
execute as @a[tag=!crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 2
execute as @a[tag=!crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] at @s run playsound minecraft:entity.experience_orb.pickup master @s ~ ~1 ~ 0.3 1.5

tag @a[tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b,id:"minecraft:knowledge_book"},{Slot:26b,id:"minecraft:filled_map"}]}] add update_inventory

tag @a[tag=!viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:35b}]}] add update_inv_view
tag @a[tag=viewing_others,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:35b}]}] remove viewing_others
tag @a[tag=update_inv_view] add viewing_others
tag @a[tag=update_inv_view] remove update_inv_view

tag @a[tag=!view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] add update_logs
tag @a[tag=view_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] remove view_logs
tellraw @a[tag=update_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"text":"Game logs enabled in chat.","color":"gray","italic":true}]
tellraw @a[tag=!view_logs,tag=!update_logs,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:17b}]}] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"text":"Game logs disabled in chat.","color":"gray","italic":true}] 
tag @a[tag=update_logs] add view_logs
tag @a[tag=update_logs] remove update_logs

tag @a[tag=!crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] add update_crouch
tag @a[tag=crouch_mechanic,tag=!disable_inventory_checks,nbt=!{Inventory:[{Slot:26b}]}] remove crouch_mechanic
tag @a[tag=update_crouch] add crouch_mechanic
tag @a[tag=update_crouch] remove update_crouch

tag @a[gamemode=!creative,tag=disable_inventory_checks] remove disable_inventory_checks
tag @a[tag=controller_inv_check] remove controller_inv_check