execute as @e[tag=token] if score @s player_id = current_controller player_id at @s as @a[scores={player_id=1..}] if score @s player_id = @e[tag=token,sort=nearest,limit=1] player_id run tag @s add actor
execute store result score action_state game_state run data get entity @a[tag=actor,limit=1] SelectedItem.tag.ActionID
execute as @a[tag=actor] at @s run playsound minecraft:ui.button.click master @s ~ ~1 ~ 0.3 1.5
execute as CanadianHybrid run scoreboard players list action_state

scoreboard players set action_delay timer 8


function monopoly:system/update_message_targets
execute if score action_state game_state matches -1 as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" ended their turn.","color":"gray","italic":true}] 
execute if score action_state game_state matches -1 run function monopoly:system/progress_turn_order

execute if score action_state game_state matches 1 as @e[tag=token,scores={player_id=1}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 1 as @e[tag=token,scores={player_id=1}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 1 if entity @e[tag=token,scores={player_id=1}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 2 as @e[tag=token,scores={player_id=2}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 2 as @e[tag=token,scores={player_id=2}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 2 if entity @e[tag=token,scores={player_id=2}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 3 as @e[tag=token,scores={player_id=3}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 3 as @e[tag=token,scores={player_id=3}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 3 if entity @e[tag=token,scores={player_id=3}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 4 as @e[tag=token,scores={player_id=4}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 4 as @e[tag=token,scores={player_id=4}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 4 if entity @e[tag=token,scores={player_id=4}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 5 as @e[tag=token,scores={player_id=5}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 5 as @e[tag=token,scores={player_id=5}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 5 if entity @e[tag=token,scores={player_id=5}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 6 as @e[tag=token,scores={player_id=6}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] unless score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-2.5 ~ ~45
execute if score action_state game_state matches 6 as @e[tag=token,scores={player_id=6}] at @s as @e[type=marker,tag=space,sort=nearest,limit=1] if score @s space_id matches 10 at @s run tp @a[tag=actor] ^ ^ ^-1 ~ ~45
execute if score action_state game_state matches 6 if entity @e[tag=token ,scores={player_id=6}] as @a[tag=actor] at @s run playsound minecraft:entity.illusioner.mirror_move player @s ~ ~1 ~ 0.5 1.5

execute if score action_state game_state matches 7 run scoreboard players set turn_state game_state -1
execute if score action_state game_state matches 7 run scoreboard players reset @e[tag=token,scores={payment_to=1..}] payment_to
execute if score action_state game_state matches 7 run tag @e[tag=token,tag=extra_turn] remove extra_turn
execute if score action_state game_state matches 7 run stopsound @a master minecraft:entity.player.levelup
execute if score action_state game_state matches 7 run tag @e[tag=token,tag=move_backwards] remove move_backwards
execute if score action_state game_state matches 7 run tag @e[tag=token,tag=hide_count] remove hide_count
execute if score action_state game_state matches 7 run tag @e[tag=token,tag=pay_double] remove pay_double
execute if score action_state game_state matches 7 run scoreboard players set dice_roll timer 58

execute if score action_state game_state matches 8 run scoreboard players operation previous_turn_state game_state = turn_state game_state
execute if score action_state game_state matches 8 run scoreboard players set turn_state game_state -2
execute if score action_state game_state matches 8 run function monopoly:board/update_property_visuals
execute if score action_state game_state matches 8 run function monopoly:board/property_management_entities
execute if score action_state game_state matches 8 as @a[tag=actor] at @s run playsound minecraft:ui.cartography_table.take_result master @s ~ ~1 ~ 2 1.3
execute if score action_state game_state matches 8 as @e[type=interaction,tag=p_manage_entity] at @s run particle poof ~ ~0.4 ~ 0.2 0.2 0.2 0.02 20
execute if score action_state game_state matches 8 as @e[type=interaction,tag=p_manage_entity] at @s run playsound minecraft:entity.zombie.attack_wooden_door block @a ~ ~ ~ 0.05 1.2 0.005
execute if score action_state game_state matches 8 as @a at @s run playsound minecraft:block.enchantment_table.use block @a ~ ~1 ~ 2 1.5

execute if score action_state game_state matches 9 as @e[tag=token,scores={movement=1..}] at @s run playsound minecraft:entity.enderman.teleport neutral @a ~ ~0.5 ~ 0.5 1.2
execute if score action_state game_state matches 9 as @e[tag=token,scores={movement=1..}] at @s run particle poof ~ ~0.5 ~ 0 0.1 0 0.05 10
execute if score action_state game_state matches 9 if entity @e[tag=token,tag=!move_backwards,tag=moving,scores={space_id=0,movement=1..}] as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" passed ","color":"gray","italic":true},{"text":"Go","color":"green","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score action_state game_state matches 9 if entity @e[tag=token,tag=!move_backwards,tag=moving,scores={space_id=0,movement=1..}] run function monopoly:money/go_money
execute if score action_state game_state matches 9 run scoreboard players add @e[tag=token,tag=move_backwards,scores={movement=1..}] space_id 2
execute if score action_state game_state matches 9 as @e[tag=token,tag=!move_backwards,scores={movement=1..}] run scoreboard players operation @s space_id += @s movement
execute if score action_state game_state matches 9 as @e[tag=token,tag=move_backwards,scores={movement=1..}] run scoreboard players operation @s space_id -= @s movement
execute if score action_state game_state matches 9 run scoreboard players remove @e[tag=token,scores={movement=1..}] space_id 1
execute if score action_state game_state matches 9 if entity @e[tag=token,scores={space_id=41..}] as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" passed ","color":"gray","italic":true},{"text":"Go","color":"green","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score action_state game_state matches 9 if entity @e[tag=token,scores={space_id=41..}] run function monopoly:money/go_money
execute if score action_state game_state matches 9 run scoreboard players remove @e[tag=token,scores={space_id=40..}] space_id 40
execute if score action_state game_state matches 9 run scoreboard players add @e[tag=token,scores={space_id=..-1}] space_id 40
execute if score action_state game_state matches 9 run scoreboard players set @e[tag=token,scores={movement=1..}] movement 1
execute if score action_state game_state matches 9 as @e[type=marker,tag=space] at @s as @e[tag=token,scores={movement=1}] if score @s space_id = @e[type=marker,tag=space,sort=nearest,limit=1] space_id run tp @s ~ ~ ~
execute if score action_state game_state matches 9 as @e[tag=token,scores={movement=1..}] at @s run playsound minecraft:entity.enderman.teleport neutral @a ~ ~0.5 ~ 0.5 1.2
execute if score action_state game_state matches 9 as @e[tag=token,scores={movement=1..}] at @s run particle minecraft:witch ~ ~0.5 ~ 0.1 0.3 0.1 0.2 30

execute if score action_state game_state matches 10 run scoreboard players set turn_state game_state 1
execute if score action_state game_state matches 10 as @a[tag=actor] at @s run playsound minecraft:item.book.page_turn player @s ~ ~1 ~ 2 1.2
execute if score action_state game_state matches 10 as @a[tag=actor] at @s run playsound minecraft:item.book.page_turn player @s ~ ~1 ~ 2 1.4
execute if score action_state game_state matches 10 as @a[tag=actor] at @s run playsound minecraft:entity.item.pickup player @s ~ ~1 ~ 0.8 2
execute if score action_state game_state matches 10 if entity @e[type=item,tag=chance] run function monopoly:board/use_chance_card
execute if score action_state game_state matches 10 if entity @e[type=item,tag=community_chest] run function monopoly:board/use_community_chest_card
execute if score action_state game_state matches 10 run kill @e[type=minecraft:text_display,tag=card_text]
execute if score action_state game_state matches 10 run kill @e[type=item,tag=card]

execute if score action_state game_state matches 11 run scoreboard players set turn_state game_state 1
execute if score action_state game_state matches 11 if score pending_turn_state game_state matches 1.. run scoreboard players operation turn_state game_state = pending_turn_state game_state
execute if score action_state game_state matches 11 if score pending_turn_state game_state matches ..-1 run scoreboard players operation turn_state game_state = pending_turn_state game_state
execute if score action_state game_state matches 11 as @e[tag=token,scores={money_owed=1..,payment_to_pending=1..}] run scoreboard players operation @s payment_to = @s payment_to_pending
execute if score action_state game_state matches 11 as @e[tag=token,scores={money_owed=1..,payment_to_pending=1..}] run scoreboard players reset @s payment_to_pending
execute if score action_state game_state matches 11 run scoreboard players operation current_controller player_id = current_turn player_id
execute if score action_state game_state matches 11 as @e[tag=token,scores={money_owed=1..}] run scoreboard players operation @s payment += @s money_owed
execute if score action_state game_state matches 11 as @e[tag=token,scores={money_owed=1..}] run scoreboard players reset @s money_owed

execute if score action_state game_state matches 12 run scoreboard players set turn_state game_state 9

execute if score action_state game_state matches 13 run scoreboard players set turn_state game_state 1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_controller]","italic":true},{"text":" purchased ","color":"gray","italic":true},{"selector":"@e[type=marker,tag=space,sort=nearest,limit=1]","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players operation @s payment += @s buy_cost
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id run scoreboard players set @s property_state 0
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id run scoreboard players operation @s player_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] player_id
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run particle poof ^ ^0.5 ^2.5 0.2 0.2 0.2 0.1 20
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:ui.stonecutter.take_result block @a ^ ^0.5 ^2.5 0.5 0.5 0.1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:block.piston.extend block @a ^ ^0.5 ^2.5 1 2 0.1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:block.wooden_door.open block @a ^ ^0.5 ^2.5 1 0.5 0.1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:block.anvil.use block @a ^ ^0.5 ^2.5 0.5 1.6 0.1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:entity.player.levelup block @a ^ ^0.5 ^2.5 0.5 0.8 0.1
execute if score action_state game_state matches 13 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id at @s run playsound minecraft:entity.zombie_villager.cure block @a ^ ^0.5 ^2.5 0.4 2 0.1
execute if score action_state game_state matches 13 run function monopoly:board/update_property_visuals

execute if score action_state game_state matches 14 run scoreboard players set turn_state game_state 1
execute if score action_state game_state matches 14 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id at @s as @e[type=marker,tag=space] if score @s space_id = @e[tag=token,scores={player_id=1..},sort=nearest,limit=1] space_id run tag @s add needs_auction

execute if score action_state game_state matches 15 run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_controller,limit=1]","italic":true},{"text":" accepted the trade offer. ","color":"gray","italic":true}] 
execute if score action_state game_state matches 15 run function monopoly:trade/accept_trade

execute if score action_state game_state matches 16 run function monopoly:trade/setup_trade

execute if score action_state game_state matches 17 run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@e[tag=msg_sys_controller,limit=1]","italic":true},{"text":" declined the trade offer. ","color":"gray","italic":true}] 
execute if score action_state game_state matches 17 run function monopoly:trade/cancel_trade

execute if score action_state game_state matches 18 as @e[tag=msg_sys_turn] run tellraw @a[tag=view_logs] [{"text":"<","color":"dark_gray"},{"text":"!","color":"gray"},{"text":"> ","color":"dark_gray"},{"selector":"@s","italic":true},{"text":" was released from ","color":"gray","italic":true},{"text":"Pillager Outpost","color":"dark_red","italic":true},{"text":".","color":"gray","italic":true}] 
execute if score action_state game_state matches 18 run scoreboard players set turn_state game_state -5
execute if score action_state game_state matches 18 as @e[tag=token,scores={player_id=1..}] if score @s player_id = current_controller player_id run scoreboard players add @s payment 50
execute if score action_state game_state matches 18 run scoreboard players add free_parking money 50
execute if score action_state game_state matches 18 run function monopoly:board/free_parking_money_visual

execute if score action_state game_state matches 19 run scoreboard players set turn_state game_state -5
execute if score action_state game_state matches 19 as @a[tag=actor] if score @s player_id = jail_card_chance player_id unless score @s player_id = jail_card_community_chest player_id run scoreboard players reset jail_card_chance player_id
execute if score action_state game_state matches 19 as @a[tag=actor] unless score @s player_id = jail_card_chance player_id if score @s player_id = jail_card_community_chest player_id run scoreboard players reset jail_card_community_chest player_id
execute if score action_state game_state matches 19 as @a[tag=actor] if score @s player_id = jail_card_chance player_id if score @s player_id = jail_card_community_chest player_id run scoreboard players reset jail_card_chance player_id

execute if score action_state game_state matches 20 run scoreboard players set no_funds timer 20
execute if score action_state game_state matches 20 as @a[tag=actor] at @s run playsound minecraft:block.note_block.bass master @s ~ ~1 ~ 1.5 0.7

execute if score action_state game_state matches 21 run scoreboard players set turn_state game_state 2
execute if score action_state game_state matches 21 as @a[tag=actor] at @s run playsound minecraft:block.note_block.bass block @s ~ ~1 ~ 1 1.5
execute if score action_state game_state matches 21 run title @a[tag=actor] actionbar ""

execute if score action_state game_state matches 22 run function monopoly:system/bankrupt_current_controller

execute if score action_state game_state matches 23 as @e[tag=token,scores={payment_pending=1..}] run scoreboard players set turn_state game_state 1
execute if score action_state game_state matches 23 as @e[tag=token,scores={payment_pending=1..}] run scoreboard players operation @s payment += @s payment_pending
execute if score action_state game_state matches 23 as @e[tag=token,scores={payment_pending=1..}] run scoreboard players reset @s payment_pending




tag @a[tag=actor] remove actor



# -1 Move to next turn

# 1 - 6 	Teleport
# 7 		Roll dice (start turn)
# 8 		Manage Properties
# 9 		TP Token to Destination
# 10 		Take Card
# 11 		Pay Bail
# 12 		Declare Bankruptcy
# 13 		Buy Available Property
# 14 		Auction Available Property
# 15 		Confirm Trade
# 16 		Counter Trade
# 17 		Decline Trade
# 19 		Pay Bail
# 19 		Use Jail Free Card
# 20 		Insufficient Funds
# 21 		Decline Bankruptcy Confirmation
# 22 		Confirm Bankruptcy Confirmation